Search results

GridModel API in JavaScript (ES5) Grid API control

Interface for a class Grid

Properties

actionBegin

EmitType<PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc., starts.

import { Grid, Page, PageEventArgs } from '@syncfusion/ej2-grids';
import { orderDataSource } from './data-source';

Grid.Inject(Page);

let grid: Grid = new Grid({
  dataSource: orderDataSource,
  allowPaging: true,
  // For Paging action
  actionBegin: (args: PageEventArgs) => {
    console.log(args.requestType);
  }
});
grid.appendTo("#Grid");

actionComplete

EmitType<PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc. are completed.

actionFailure

EmitType<FailureEventArgs>

Triggers when any Grid action failed to achieve the desired results.

batchAdd

EmitType<BatchAddArgs>

Triggers when records are added in batch mode.

batchCancel

EmitType<BatchCancelArgs>

Triggers when cancel the batch edit changes batch mode.

batchDelete

EmitType<BatchDeleteArgs>

Triggers when records are deleted in batch mode.

beforeAutoFill

EmitType<BeforeAutoFillEventArgs>

Triggers before Grid autoFill action.

beforeBatchAdd

EmitType<BeforeBatchAddArgs>

Triggers before records are added in batch mode.

beforeBatchDelete

EmitType<BeforeBatchDeleteArgs>

Triggers before records are deleted in batch mode.

beforeBatchSave

EmitType<BeforeBatchSaveArgs>

Triggers before records are saved in batch mode.

beforeCopy

EmitType<BeforeCopyEventArgs>

Triggers before Grid copy action.

beforeDataBound

EmitType<BeforeDataBoundArgs>

Triggers before data is bound to Grid.

beforeDetailTemplateDetach

EmitType<DetailTemplateDetachArgs>

Event triggered before a detail template row is removed from the DOM. This event allows executing necessary cleanup operations or additional actions before the detail row is detached.

beforeExcelExport

EmitType<Object>

Triggers before Grid data is exported to Excel file.

beforeOpenAdaptiveDialog

EmitType<AdaptiveDialogEventArgs>

Triggers before adaptive filter and sort dialogs open.

beforeOpenColumnChooser

EmitType<ColumnChooserEventArgs>

Triggers before the columnChooser open.

beforePaste

EmitType<BeforePasteEventArgs>

Triggers before Grid paste action.

beforePdfExport

EmitType<Object>

Triggers before Grid data is exported to PDF document.

beforePrint

EmitType<PrintEventArgs>

Triggers before the print action starts.

beginEdit

EmitType<BeginEditArgs>

Triggers before the record is to be edit.

cellDeselected

EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting

EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit

EmitType<CellEditArgs>

Triggers when the cell is being edited.

cellSave

EmitType<CellSaveArgs>

Triggers when the cell is being saved.

cellSaved

EmitType<CellSaveArgs>

Triggers after the cell is saved.

cellSelected

EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting

EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

checkBoxChange

EmitType<CheckBoxChangeEventArgs>

Triggers when the check box state change in checkbox column.

columnDataStateChange

EmitType<ColumnDataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done to get column dataSource. In this event,the current view column data and total record count should be assigned to the column dataSource based on the action performed.

columnDeselected

EmitType<ColumnDeselectEventArgs>

Triggers when a selected column is deselected.

columnDeselecting

EmitType<ColumnDeselectEventArgs>

Triggers before deselecting the selected column.

columnDrag

EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart

EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop

EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick

EmitType<MenuEventArgs>

Triggers when click on column menu.

columnMenuOpen

EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

columnSelected

EmitType<ColumnSelectEventArgs>

Triggers after a column is selected.

columnSelecting

EmitType<ColumnSelectingEventArgs>

Triggers before column selection occurs.

commandClick

EmitType<CommandClickEventArgs>

Triggers when command button is clicked.

contextMenuClick

EmitType<ContextMenuClickEventArgs>

Triggers when click on context menu.

contextMenuOpen

EmitType<BeforeOpenCloseMenuEventArgs>

Triggers before context menu opens.

created

EmitType<Object>

Triggers when the component is created.

dataBound

EmitType<Object>

Triggers when data source is populated in the Grid.

dataSourceChanged

EmitType<DataSourceChangedEventArgs>

Triggers when the grid data is added, deleted and updated. Invoke the done method from the argument to start render after edit operation.

dataStateChange

EmitType<DataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done. In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed

EmitType<Object>

Triggers when the component is destroyed.

detailDataBound

EmitType<DetailDataBoundEventArgs>

Triggers after detail row expands.

This event triggers at initial expand.

excelAggregateQueryCellInfo

EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to Excel document. You can also customize the PDF cells.

excelExportComplete

EmitType<ExcelExportCompleteArgs>

Triggers after Grid data is exported to Excel file.

excelHeaderQueryCellInfo

EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file. You can also customize the Excel cells.

excelQueryCellInfo

EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file. You can also customize the Excel cells.

exportDetailDataBound

EmitType<ExportDetailDataBoundEventArgs>

Triggers before exporting each detail Grid to PDF document.

exportDetailTemplate

EmitType<ExportDetailTemplateEventArgs>

Triggers before exporting each detail template.

exportGroupCaption

EmitType<ExportGroupCaptionEventArgs>

Triggers before exporting each caption row to PDF/Excel/CSV document. You can also customize the export caption row values.

headerCellInfo

EmitType<HeaderCellInfoEventArgs>

Triggered for stacked header.

keyPressed

EmitType<KeyboardEventArgs>

Triggers when any keyboard keys are pressed inside the grid.

lazyLoadGroupCollapse

EmitType<LazyLoadArgs>

Triggers when collapse the caption row in lazy load grouping.

lazyLoadGroupExpand

EmitType<LazyLoadArgs>

Triggers when expand the caption row in lazy load grouping.

load

EmitType<Object>

This event allows customization of Grid properties before rendering.

pdfAggregateQueryCellInfo

EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to PDF document. You can also customize the PDF cells.

pdfExportComplete

EmitType<PdfExportCompleteArgs>

Triggers after Grid data is exported to PDF document.

pdfHeaderQueryCellInfo

EmitType<PdfHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfQueryCellInfo

EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

printComplete

EmitType<PrintEventArgs>

Triggers after print action is completed.

queryCellInfo

EmitType<QueryCellInfoEventArgs>

Triggered every time a request is made to access cell information, element, or data. This will be triggered before the cell element is appended to the Grid element.

recordClick

EmitType<RecordClickEventArgs>

Triggers when record is clicked.

recordDoubleClick

EmitType<RecordDoubleClickEventArgs>

Triggers when record is double clicked.

resizeStart

EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop

EmitType<ResizeArgs>

Triggers when column resize ends.

resizing

EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound

EmitType<RowDataBoundEventArgs>

Triggered every time a request is made to access row information, element, or data. This will be triggered before the row element is appended to the Grid element.

rowDeselected

EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting

EmitType<RowDeselectingEventArgs>

Triggers before deselecting the selected row.

rowDrag

EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart

EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper

EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop

EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected

EmitType<RowSelectEventArgs>

Triggers after a row is selected.

rowSelecting

EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

toolbarClick

EmitType<ClickEventArgs>

Triggers when toolbar item is clicked.

adaptiveUIMode

AdaptiveMode

One of the adaptiveUIMode enumeration that specifies the Adaptive Mode. The default value is Both.

aggregates

AggregateRowModel[]

Configures the Grid aggregate rows.

<div id='Grid'></grid>
import { Grid, Aggregate } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(Aggregate);
let grid: Grid = new Grid({
    dataSource: data,
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', width: 120 },
        { field: 'Freight', headerText: 'Freight', width: 150, textAlign: 'Right', format:'C2' },
    ],
    aggregates: [{
        columns: [{type: 'Sum',field: 'Freight',format: 'C2',footerTemplate: 'Sum: ${Sum}'}]
    }]
});
grid.appendTo('#Grid');

Check the Aggregates for its configuration.

allowExcelExport

boolean

If allowExcelExport set to true, then it will allow the user to export grid to Excel file.

Check the ExcelExport to configure exporting document.

<div id='Grid'></grid>
import { Grid, Toolbar, ExcelExport } from '@syncfusion/ej2-grids';
import { orderDetails } from './data-source';
Grid.Inject(Toolbar, ExcelExport);
let grid: Grid = new Grid(
  {
    dataSource: orderDetails,
    allowExcelExport: true,
    toolbar: ['ExcelExport'],
  });
grid.appendTo('#Grid');

allowFiltering

boolean

If allowFiltering set to true the filter bar will be displayed. If set to false the filter bar will not be displayed. Filter bar allows the user to filter grid records with required criteria.

Check the Filtering to customize its default behavior.

<div id='Grid'></grid>
import { Grid, Filter } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Filter);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowFiltering: true,
  });
grid.appendTo('#Grid');

allowGrouping

boolean

If allowGrouping set to true, then it will allow the user to dynamically group or ungroup columns. Grouping can be done by drag and drop columns from column header to group drop area.

Check the Grouping to customize its default behavior.

<div id='Grid'></grid>
import { Grid, Group } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Group);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowGrouping: true,
  });
grid.appendTo('#Grid');

allowKeyboard

boolean

Enables or disables the key board interaction of Grid.

allowMultiSorting

boolean

If allowMultiSorting set to true, then it will allow the user to sort multiple column in the grid.

allowSorting should be true.

<div id='Grid'></grid>
import { Grid, Sort } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Sort);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowSorting: true,
    allowMultiSorting: true,
  });
grid.appendTo('#Grid');

allowPaging

boolean

If allowPaging is set to true, the pager renders at the footer of the Grid. It is used to handle page navigation in the Grid.

Check the Paging to configure the grid pager.

allowPdfExport

boolean

If allowPdfExport set to true, then it will allow the user to export grid to Pdf file.

Check the Pdfexport to configure the exporting document.

<div id='Grid'></grid>
import { Grid, Toolbar, PdfExport } from '@syncfusion/ej2-grids';
import { orderDetails } from './data-source';
Grid.Inject(Toolbar, PdfExport);
let grid: Grid = new Grid(
  {
    dataSource: orderDetails,
    allowPdfExport: true,
    toolbar: ['PdfExport'],
  });
grid.appendTo('#Grid');

allowReordering

boolean

If allowReordering is set to true, Grid columns can be reordered. Reordering can be done by drag and drop of a particular column from one index to another index.

If Grid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.

<div id='Grid'></grid>
import { Grid, Reorder } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Reorder);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowReordering: true,
  });
grid.appendTo('#Grid');

allowResizing

boolean

If allowResizing is set to true, Grid columns can be resized.

<div id='Grid'></grid>
import { Grid, Resize } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Resize );
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowResizing: true,
  });
grid.appendTo('#Grid');

allowRowDragAndDrop

boolean

If allowRowDragAndDrop is set to true, you can drag and drop grid rows at another grid.

<div id='Grid'></grid>
import { Grid, RowDD  } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(RowDD );
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowRowDragAndDrop: true, 
  });
grid.appendTo('#Grid');

allowSelection

boolean

If allowSelection is set to true, it allows selection of (highlight row) Grid records by clicking it.

<div id='Grid'></grid>
import { Grid, Selection  } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Selection );
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowSelection: true,
  });
grid.appendTo('#Grid');

allowSorting

boolean

If allowSorting is set to true, it allows sorting of grid records when column header is clicked.

Check the Sorting to customize its default behavior.

<div id='Grid'></grid>
import { Grid, Sort } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Sort);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowSorting: true,
  });
grid.appendTo('#Grid');

allowTextWrap

boolean

If allowTextWrap set to true, then text content will wrap to the next line when its text content exceeds the width of the Column Cells.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowTextWrap: true, 
  });
grid.appendTo('#Grid');

autoFit

boolean

If autoFit set to true, then it will auto fit the columns based on given width.

childGrid

GridModel

Defines Grid options to render child Grid. It requires the queryString for parent and child relationship.

Check the Child Grid for its configuration.

clipMode

ClipMode

Defines the mode of clip. The available modes are, Clip: Truncates the cell content when it overflows its area. Ellipsis: Displays ellipsis when the cell content overflows its area. EllipsisWithTooltip: Displays ellipsis when the cell content overflows its area, also it will display the tooltip while hover on ellipsis is applied.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    clipMode: 'Ellipsis',
  });
grid.appendTo('#Grid');

columnChooserSettings

ColumnChooserSettingsModel

Configures the column chooser in the Grid.

columnMenuItems

ColumnMenuItem[] | ColumnMenuItemModel[]

columnMenuItems defines both built-in and custom column menu items.

The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • Filter - Filter options will show based on filterSettings property like checkbox filter, excel filter, menu filter.

columnQueryMode

ColumnQueryModeType

columnQueryModeprovides options to retrive data from the datasource.Their types are

  • All: It Retrives whole datasource.
  • Schema: Retrives data for all the defined columns in grid from the datasource.
  • ExcludeHidden: Retrives data only for visible columns of grid from the dataSource.

columns

Column[] | string[] | ColumnModel[]

Defines the schema of dataSource. If the columns declaration is empty or undefined then the columns are automatically generated from data source.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    columns: [
      { field: 'CategoryName', headerText: 'Category Name', width: 150 },
      { field: 'ProductName', headerText: 'Product Name', width: 150 },
    ],
  });
grid.appendTo('#Grid');

contextMenuItems

ContextMenuItem[] | ContextMenuItemModel[]

contextMenuItems defines both built-in and custom context menu items.

The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • Edit - Edit the current record.
  • Delete - Delete the current record.
  • Save - Save the edited record.
  • Cancel - Cancel the edited state.
  • Copy - Copy the selected records.
  • PdfExport - Export the grid as Pdf format.
  • ExcelExport - Export the grid as Excel format.
  • CsvExport - Export the grid as CSV format.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • FirstPage - Go to the first page.
  • PrevPage - Go to the previous page.
  • LastPage - Go to the last page.
  • NextPage - Go to the next page.

cssClass

string

Defines the own class for the grid element.

currentAction

ActionArgs

Gets or sets the current action details.

currentViewData

Object[]

Gets the currently visible records of the Grid.

dataSource

Object | DataManager | DataResult

It is used to render grid table rows. If the dataSource is an array of JavaScript objects, then Grid will create instance of DataManager from this dataSource. If the dataSource is an existing DataManager, the Grid will not initialize a new one.

Check the available Adaptors to customize the data operation.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
  });
grid.appendTo('#Grid');

detailTemplate

string | Function

The detail template allows you to show or hide additional information about a particular row.

It accepts either the template string or the HTML element ID.

editSettings

EditSettingsModel

Configures the edit settings.

<div id='Grid'></grid>
import { Grid, Toolbar, Edit } from '@syncfusion/ej2-grids';
import { data } from './data-source';
Grid.Inject(Toolbar,Edit);
let grid: Grid = new Grid({
    dataSource: data,
    toolbar: ['Add', 'Edit', 'Delete', 'Update', 'Cancel'],
    editSettings: { allowEditing: true, allowAdding: true, allowDeleting: true, mode: 'Normal' },
});
grid.appendTo('#Grid');

ej2StatePersistenceVersion

string

Defines the version for Grid persistence.

emptyRecordTemplate

string | Function

The empty record template that renders customized element or text or image instead of displaying the empty record message in the grid.

It accepts either the template string or the HTML element ID.

enableAdaptiveUI

boolean

If enableAdaptiveUI set to true the grid filter, sort, and edit dialogs render adaptively.

enableAltRow

boolean

If enableAltRow is set to true, the grid will render with e-altrow CSS class to the alternative tr elements.

Check the AltRow to customize the styles of alternative rows.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    enableAltRow: false,
  });
grid.appendTo('#Grid');

enableAutoFill

boolean

If enableAutoFill is set to true, then the auto fill icon will displayed on cell selection for copy cells. It requires the selection mode to be Cell and cellSelectionMode to be Box.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    enableAutoFill: true,
    selectionSettings:{mode:'Cell',cellSelectionMode:'Box'}
  });
grid.appendTo('#Grid');

enableColumnVirtualization

boolean

If enableColumnVirtualization set to true, then the Grid will render only the columns visible within the view-port and load subsequent columns on horizontal scrolling. This helps to load large dataset of columns in Grid.

<div id='Grid'></grid>
import { Grid, VirtualScroll} from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(VirtualScroll);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    enableVirtualization: true,
    enableColumnVirtualization: true,
    height: 300,
  });
grid.appendTo('#Grid');

enableHeaderFocus

boolean

If enableHeaderFocus set to true, then header element will be focused when focus moves to grid.

enableHover

boolean

If enableHover is set to true, the row hover is enabled in the Grid.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    enableHover: true,
  });
grid.appendTo('#Grid');

enableHtmlSanitizer

boolean

Specifies whether to display or remove the untrusted HTML values in the Grid component. If ‘enableHtmlSanitizer’ set to true, the component will sanitize any suspected untrusted strings and scripts before rendering them.

enableImmutableMode

boolean

If enableImmutableMode is set to true, the grid will reuse old rows if it exists in the new result instead of full refresh while performing the grid actions.

enableInfiniteScrolling

boolean

If enableInfiniteScrolling set to true, then the data will be loaded in Grid when the scrollbar reaches the end. This helps to load large dataset in Grid.

<div id='Grid'></grid>
import { Grid, InfiniteScroll} from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(InfiniteScroll);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    enableInfiniteScrolling: true,
    height: 300,   
  });
grid.appendTo('#Grid');

enablePersistence

boolean

Enable or disable persisting component’s state between page reloads.

enableRtl

boolean

Enable or disable rendering component in right to left direction.

enableStickyHeader

boolean

If ‘enableStickyHeader’ set to true, then the user can able to make the column headers visible when the document is scrolled.

enableVirtualMaskRow

boolean

Specifies the shimmer effect for Grid virtual and infinite scrolling.

enableVirtualization

boolean

If enableVirtualization set to true, then the Grid will render only the rows visible within the view-port and load subsequent rows on vertical scrolling. This helps to load large dataset in Grid.

<div id='Grid'></grid>
import { Grid, VirtualScroll } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(VirtualScroll);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    enableVirtualization: true,
    height: 300  
  });
grid.appendTo('#Grid');

exportGrids

string[]

Defines the id of the grids that needs to be exported

filterSettings

FilterSettingsModel

Configures the filter settings of the Grid.

<div id='Grid'></grid>
import { Grid, Filter } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Filter);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    allowFiltering: true,
    filterSettings: { type:'Menu'},
  });
grid.appendTo('#Grid');

frozenColumns

number

Gets or sets the number of frozen columns.

<div id='Grid'></grid>
import { Grid, Freeze } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Freeze);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    frozenColumns: 2,
  });
grid.appendTo('#Grid');

frozenRows

number

Gets or sets the number of frozen rows.

<div id='Grid'></grid>
import { Grid, Freeze } from '@syncfusion/ej2-grids';
import { categoryData } from './data-source';
Grid.Inject(Freeze);
let grid: Grid = new Grid(
  {
    dataSource: categoryData,
    frozenRows: 2,
  });
grid.appendTo('#Grid');

gridLines

GridLine

Defines the mode of grid lines. The available modes are,

  • Both: Displays both horizontal and vertical grid lines.
  • None: No grid lines are displayed.
  • Horizontal: Displays the horizontal grid lines only.
  • Vertical: Displays the vertical grid lines only.
  • Default: Displays grid lines based on the theme.
<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
let grid: Grid = new Grid({
    dataSource: data,
    gridLines: 'Both',
});
grid.appendTo('#Grid');

groupSettings

GroupSettingsModel

Configures the group settings.

<div id='Grid'></grid>
import { Grid, Group } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(Group);
let grid: Grid = new Grid({
    dataSource: data,
    allowGrouping: true,
    groupSettings: { columns: ['Freight'] },
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', width: 120 },
        { field: 'Freight', headerText: 'Freight', width: 150, textAlign: 'Right', format:'C2' },
    ],
});
grid.appendTo('#Grid');

height

string | number

Defines the scrollable height of the grid content.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
let grid: Grid = new Grid({
    dataSource: data,
    height: '400',
});
grid.appendTo('#Grid');

hierarchyPrintMode

HierarchyGridPrintMode

Defines the hierarchy grid print modes. The available modes are

  • Expanded - Prints the master grid with expanded child grids.
  • All - Prints the master grid with all the child grids.
  • None - Prints the master grid alone.

infiniteScrollSettings

InfiniteScrollSettingsModel

Configures the infinite scroll settings.

<div id='Grid'></grid>
import { Grid, InfiniteScroll } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(InfiniteScroll);
let grid: Grid = new Grid({
    dataSource: data,
    height: 300,
    pageSettings: { pageSize: 50 },
    enableInfiniteScrolling: true,
    infiniteScrollSettings: { enableCache: true, maxBlocks: 3, initialBlocks: 3 },
});
grid.appendTo('#Grid');

loadingIndicator

LoadingIndicatorModel

Configures the Loading Indicator of the Grid.

locale

string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

pageSettings

PageSettingsModel

Configures the pager in the Grid.

<div id='Grid'></grid>
import { Grid, Page } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(Page);
let grid: Grid = new Grid({
    dataSource: data,
    allowPaging:true,
    pageSettings: { currentPage: 1, pageSize: 12, pageCount: 8, pageSizes: true },
});
grid.appendTo('#Grid');

pagerTemplate

string | Function

It used to render pager template

parentDetails

ParentDetails

Gets the parent Grid details.

printMode

PrintMode

Defines the print modes. The available print modes are

  • AllPages: Prints all pages of the Grid.
  • CurrentPage: Prints the current page of the Grid.
<div id='Grid'></grid>
import { Grid, Page, Toolbar } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(Page,Toolbar);
let grid: Grid = new Grid({
    dataSource: data,
    toolbar: ['Print'],
    printMode: 'CurrentPage',
    allowPaging: true,
});
grid.appendTo('#Grid');

query

Query

Defines the external Query that will be executed along with data processing.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { DataManager, Query, ODataAdaptor } from '@syncfusion/ej2-data';
let data: DataManager = new DataManager({
    url: 'https://js.syncfusion.com/demos/ejServices/Wcf/Northwind.svc/Orders/?$top=7',
    adaptor: new ODataAdaptor
});
let grid: Grid = new Grid({
    dataSource: data,
    query: new Query().addParams('ej2grid', 'true'),
});
grid.appendTo('#Grid');

queryString

string

Defines the relationship between parent and child datasource. It acts as the foreign key for parent datasource.

resizeSettings

ResizeSettingsModel

Defines the resizing behavior of the Grid.

rowDropSettings

RowDropSettingsModel

Configures the row drop settings.

rowHeight

number

Defines the height of Grid rows.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
let grid: Grid = new Grid({
    dataSource: data,
    rowHeight: 20,
});
grid.appendTo('#Grid');

rowRenderingMode

RowRenderingDirection

Defines the grid row elements rendering direction. The available directions are,

  • Horizontal: Renders the grid row elements in the horizontal direction
  • Vertical: Renders the grid row elements in the vertical direction

rowTemplate

string | Function

The row template that renders customized rows from the given template. By default, Grid renders a table row for every data source item.

searchSettings

SearchSettingsModel

Configures the search behavior in the Grid.

<div id='Grid'></grid>
import { Grid, Search, Toolbar } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(Search,Toolbar);
let grid: Grid = new Grid({
    dataSource: data,
    toolbar: ['Search'],
    searchSettings: { fields: ['CustomerID'], key: 'ha' },
    columns: [ 
        { field: 'CustomerID', headerText: 'Customer ID', width: 150 },
        { field: 'Freight', headerText: 'Freight', width: 150, textAlign: 'Right', format:'C2' },
    ]
});
grid.appendTo('#Grid');

selectedRowIndex

number

The selectedRowIndex allows you to select a row at initial rendering. You can also get the currently selected row index.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
let grid: Grid = new Grid({
    dataSource: data,
    selectedRowIndex: 5,
});
grid.appendTo('#Grid');

selectionSettings

SelectionSettingsModel

Configures the selection settings.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
let grid: Grid = new Grid({
    dataSource: data,
    selectionSettings: { mode: 'Cell', cellSelectionMode: 'Box', type: 'Multiple' },
});
grid.appendTo('#Grid');

showColumnChooser

boolean

If showColumnChooser is set to true, it allows you to dynamically show or hide columns.

Check the ColumnChooser for its configuration.

<div id='Grid'></grid>
import { Grid, ColumnChooser, Toolbar } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(ColumnChooser, Toolbar);
let grid: Grid = new Grid({
    dataSource: data,
    toolbar: ['ColumnChooser'],
    showColumnChooser: true,
});
grid.appendTo('#Grid');

showColumnMenu

boolean

If showColumnMenu set to true, then it will enable the column menu options in each columns.

Check the Column menu for its configuration.

<div id='Grid'></grid>
import { Grid, ColumnMenu } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(ColumnMenu);
let grid: Grid = new Grid({
    dataSource: data,
    showColumnMenu: true,
});
grid.appendTo('#Grid');

showHider

ShowHide

The showHider is used to manipulate column’s show/hide operation in the Grid.

sortSettings

SortSettingsModel

Configures the sort settings.

<div id='Grid'></grid>
import { Grid, Sort } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(Sort);
let grid: Grid = new Grid({
    dataSource: data,
    allowSorting: true,
    sortSettings: { columns: [{ field: 'OrderID', direction: 'Ascending' }] },
    columns: [
        { field: 'CustomerID', headerText: 'Customer ID', width: 150 },
        { field: 'Freight', headerText: 'Freight', width: 150, textAlign: 'Right', format:'C2' },
    ]
});
grid.appendTo('#Grid');

textWrapSettings

TextWrapSettingsModel

Configures the text wrap in the Grid.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
let grid: Grid = new Grid({
    dataSource: data,
    allowTextWrap: true,
    textWrapSettings: { wrapMode: 'Both' },
});
grid.appendTo('#Grid');

toolbar

[]

toolbar defines the ToolBar items of the Grid. It contains built-in and custom toolbar items. If a string value is assigned to the toolbar option, it is considered as the template for the whole Grid ToolBar. If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Grid’s Toolbar.

The available built-in ToolBar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected record.
  • Update: Updates the edited record.
  • Delete: Deletes the selected record.
  • Cancel: Cancels the edit state.
  • Search: Searches records by the given key.
  • Print: Prints the Grid.
  • ExcelExport - Export the Grid to Excel(excelExport() method manually to make export.)
  • PdfExport - Export the Grid to PDF(pdfExport() method manually to make export.)
  • CsvExport - Export the Grid to CSV(csvExport() method manually to make export.)

    The following code example implements the custom toolbar items.

    Check the Toolbar to customize its default items.

<div id='Grid'></grid>
import { Grid, Toolbar } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
Grid.Inject(Toolbar);
let grid: Grid = new Grid({
    dataSource: data,
    toolbar: ['Search','Print'],
});
grid.appendTo('#Grid');

toolbarTemplate

string | Function

It used to render toolbar template

width

string | number

Defines the Grid width.

<div id='Grid'></grid>
import { Grid } from '@syncfusion/ej2-grids';
import { data } from './datasource.ts';
let grid: Grid = new Grid({
    dataSource: data,
    width: '700',
});
grid.appendTo('#Grid');
Contents
Contents

GridModel

16 Dec 202524 minutes to read

Interface for a class Grid

Properties

actionBegin EmitType< PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc., starts.

    <ejs-grid [dataSource]='data' allowPaging='true' (actionBegin)='actionBegin($event)'>
    </ejs-grid>
import { Component } from '@angular/core';
import { orderDetails } from './data';
import { PageEventArgs, PageService } from '@syncfusion/ej2-angular-grids'

@Component({
  selector: 'app-root',
  templateUrl: 'app.component.html',
  providers: [PageService]
})
export class AppComponent {
  public data: Object[] = orderDetails;

  // For Paging action
  public actionBegin(args: PageEventArgs) {
    console.log(args.requestType);
  }
}

actionComplete EmitType< PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc. are completed.

actionFailure EmitType<FailureEventArgs>

Triggers when any Grid action failed to achieve the desired results.

batchAdd EmitType<BatchAddArgs>

Triggers when records are added in batch mode.

batchCancel EmitType<BatchCancelArgs>

Triggers when cancel the batch edit changes batch mode.

batchDelete EmitType<BatchDeleteArgs>

Triggers when records are deleted in batch mode.

beforeAutoFill EmitType<BeforeAutoFillEventArgs>

Triggers before Grid autoFill action.

beforeBatchAdd EmitType<BeforeBatchAddArgs>

Triggers before records are added in batch mode.

beforeBatchDelete EmitType<BeforeBatchDeleteArgs>

Triggers before records are deleted in batch mode.

beforeBatchSave EmitType<BeforeBatchSaveArgs>

Triggers before records are saved in batch mode.

beforeCopy EmitType<BeforeCopyEventArgs>

Triggers before Grid copy action.

beforeCustomFilterOpen EmitType<BeforeCustomFilterOpenEventArgs>

Event triggered before the custom filter dialog is opened.

beforeDataBound EmitType<BeforeDataBoundArgs>

Triggers before data is bound to Grid.

beforeDetailTemplateDetach EmitType<DetailTemplateDetachArgs>

Event triggered before a detail template row is removed from the DOM.
This event allows executing necessary cleanup operations or additional actions before the detail row is detached.

beforeExcelExport EmitType<Object>

Triggers before Grid data is exported to Excel file.

beforeOpenAdaptiveDialog EmitType<AdaptiveDialogEventArgs>

Triggers before adaptive filter and sort dialogs open.

beforeOpenColumnChooser EmitType<ColumnChooserEventArgs>

Triggers before the columnChooser open.

beforePaste EmitType<BeforePasteEventArgs>

Triggers before Grid paste action.

beforePdfExport EmitType<Object>

Triggers before Grid data is exported to PDF document.

beforePrint EmitType<PrintEventArgs>

Triggers before the print action starts.

beginEdit EmitType<BeginEditArgs>

Triggers before the record is to be edit.

cellDeselected EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit EmitType<CellEditArgs>

Triggers when the cell is being edited.

cellSave EmitType<CellSaveArgs>

Triggers when the cell is being saved.

cellSaved EmitType<CellSaveArgs>

Triggers after the cell is saved.

cellSelected EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

checkBoxChange EmitType<CheckBoxChangeEventArgs>

Triggers when the check box state change in checkbox column.

columnDataStateChange EmitType<ColumnDataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done to get column dataSource.
In this event,the current view column data and total record count should be assigned to the column dataSource based
on the action performed.

columnDeselected EmitType<ColumnDeselectEventArgs>

Triggers when a selected column is deselected.

columnDeselecting EmitType<ColumnDeselectEventArgs>

Triggers before deselecting the selected column.

columnDrag EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick EmitType<MenuEventArgs>

Triggers when click on column menu.

columnMenuClose EmitType<ColumnMenuOpenEventArgs>

Triggers before the column menu closes.
This event allows you to perform custom actions or cancel the closing of the column menu.

columnMenuOpen EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

columnSelected EmitType<ColumnSelectEventArgs>

Triggers after a column is selected.

columnSelecting EmitType<ColumnSelectingEventArgs>

Triggers before column selection occurs.

commandClick EmitType<CommandClickEventArgs>

Triggers when command button is clicked.

contextMenuClick EmitType<ContextMenuClickEventArgs>

Triggers when click on context menu.

contextMenuClose EmitType<ContextMenuOpenEventArgs>

Triggers before the context menu closes.
This event allows you to perform custom actions or cancel the closing of the context menu.

contextMenuOpen EmitType<ContextMenuOpenEventArgs>

Triggers before context menu opens.

created EmitType<Object>

Triggers when the component is created.

dataBound EmitType<Object>

Triggers when data source is populated in the Grid.

dataSourceChanged EmitType<DataSourceChangedEventArgs>

Triggers when the grid data is added, deleted and updated.
Invoke the done method from the argument to start render after edit operation.

dataStateChange EmitType<DataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done.
In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed EmitType<Object>

Triggers when the component is destroyed.

detailCollapse EmitType<DetailExpandCollapseArgs>

Triggers before collapsing the detail row.
This event allows to perform customize actions or cancel the collapse of the detail row.

detailDataBound EmitType<DetailDataBoundEventArgs>

Triggers after detail row expands.

This event triggers at initial expand.

detailExpand EmitType<DetailExpandCollapseArgs>

Triggers before expanding the detail row.
This event allows to perform customize actions or cancel the expansion of the detail row.

excelAggregateQueryCellInfo EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to Excel document. You can also customize the PDF cells.

excelExportComplete EmitType<ExcelExportCompleteArgs>

Triggers after Grid data is exported to Excel file.

excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file.
You can also customize the Excel cells.

excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file.
You can also customize the Excel cells.

exportDetailDataBound EmitType<ExportDetailDataBoundEventArgs>

Triggers before exporting each detail Grid to PDF document.

exportDetailTemplate EmitType<ExportDetailTemplateEventArgs>

Triggers before exporting each detail template.

exportGroupCaption EmitType<ExportGroupCaptionEventArgs>

Triggers before exporting each caption row to PDF/Excel/CSV document. You can also customize the export caption row values.

headerCellInfo EmitType<HeaderCellInfoEventArgs>

Triggered for stacked header.

keyPressed EmitType<KeyboardEventArgs>

Triggers when any keyboard keys are pressed inside the grid.

lazyLoadGroupCollapse EmitType<LazyLoadArgs>

Triggers when collapse the caption row in lazy load grouping.

lazyLoadGroupExpand EmitType<LazyLoadArgs>

Triggers when expand the caption row in lazy load grouping.

load EmitType<Object>

This event allows customization of Grid properties before rendering.

pdfAggregateQueryCellInfo EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to PDF document. You can also customize the PDF cells.

pdfExportComplete EmitType<PdfExportCompleteArgs>

Triggers after Grid data is exported to PDF document.

pdfHeaderQueryCellInfo EmitType<PdfHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

printComplete EmitType<PrintEventArgs>

Triggers after print action is completed.

queryCellInfo EmitType<QueryCellInfoEventArgs>

Triggered every time a request is made to access cell information, element, or data.
This will be triggered before the cell element is appended to the Grid element.

recordClick EmitType<RecordClickEventArgs>

Triggers when record is clicked.

recordDoubleClick EmitType<RecordDoubleClickEventArgs>

Triggers when record is double clicked.

resizeStart EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop EmitType<ResizeArgs>

Triggers when column resize ends.

resizing EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound EmitType<RowDataBoundEventArgs>

Triggered every time a request is made to access row information, element, or data.
This will be triggered before the row element is appended to the Grid element.

rowDeselected EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting EmitType<RowDeselectingEventArgs>

Triggers before deselecting the selected row.

rowDrag EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected EmitType<RowSelectEventArgs>

Triggers after a row is selected.

rowSelecting EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

toolbarClick EmitType<ClickEventArgs>

Triggers when toolbar item is clicked.

adaptiveUIMode AdaptiveMode

One of the adaptiveUIMode enumeration that specifies the Adaptive Mode. The default value is Both.

aggregates AggregateRowModel[]

Configures the Grid aggregate rows.

    <ejs-grid [dataSource]="data">
        <e-columns>
            <e-column field='CustomerName' headerText='Customer Name' width='150'></e-column>
            <e-column field='Freight' headerText='Freight' width='150' format='C2' textAlign='Right'></e-column>
        </e-columns>
        <e-aggregates>
            <e-aggregate>
                <e-columns>
                    <e-column type="Sum" field="Freight" format="C2">
                        <ng-template #footerTemplate let-data>Sum: {{data.Sum}}</ng-template>
                    </e-column>
                </e-columns>
            </e-aggregate>
        </e-aggregates>
    </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { AggregateService,GridComponent } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [AggregateService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

Check the Aggregates for its configuration.

allowExcelExport boolean

If allowExcelExport set to true, then it will allow the user to export grid to Excel file.

Check the ExcelExport to configure exporting document.

<ejs-grid [dataSource]='data' [toolbar]='toolbar' [allowExcelExport]='true'>
</ejs-grid>
import { Component, OnInit} from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, ToolbarService, ExcelExportService} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [ToolbarService, ExcelExportService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public toolbar: string[];
    public ngOnInit(): void { 
        this.data = orderDetails;
        this.toolbar = ['ExcelExport'];
    }
}

allowFiltering boolean

If allowFiltering set to true the filter bar will be displayed.
If set to false the filter bar will not be displayed.
Filter bar allows the user to filter grid records with required criteria.

Check the Filtering to customize its default behavior.

<ejs-grid [dataSource]='data' [allowFiltering]='true'>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, FilterService} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[FilterService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public ngOnInit(): void { 
        this.data = orderDetails;
    }
}

allowGrouping boolean

If allowGrouping set to true, then it will allow the user to dynamically group or ungroup columns.
Grouping can be done by drag and drop columns from column header to group drop area.

Check the Grouping to customize its default behavior.

<ejs-grid [dataSource]='data' [allowGrouping]='true'>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent,GroupService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[GroupService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

allowKeyboard boolean

Enables or disables the key board interaction of Grid.

allowMultiSorting boolean

If allowMultiSorting set to true, then it will allow the user to sort multiple column in the grid.

allowSorting should be true.

<ejs-grid [dataSource]='data' [allowSorting]='true' [allowMultiSorting]='true'>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, SortService} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[SortService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

allowPaging boolean

If allowPaging is set to true, the pager renders at the footer of the Grid. It is used to handle page navigation in the Grid.

Check the Paging to configure the grid pager.

allowPdfExport boolean

If allowPdfExport set to true, then it will allow the user to export grid to Pdf file.

Check the Pdfexport to configure the exporting document.

<ejs-grid [dataSource]='data' [toolbar]='toolbar' [allowPdfExport]='true'>
</ejs-grid>
import { Component, OnInit, ViewChild } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, ToolbarService, PdfExportService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [ToolbarService, PdfExportService ]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public toolbar: string[];
    public ngOnInit(): void { 
        this.data = orderDetails;
        this.toolbar = ['PdfExport'];
    }
}

allowReordering boolean

If allowReordering is set to true, Grid columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.

If Grid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.

<ejs-grid [dataSource]='data' [allowReordering]="true">
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, ReorderService} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[ReorderService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

allowResizing boolean

If allowResizing is set to true, Grid columns can be resized.

<ejs-grid [dataSource]='data' [allowResizing]="true">
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, ResizeService} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[ResizeService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

allowRowDragAndDrop boolean

If allowRowDragAndDrop is set to true, you can drag and drop grid rows at another grid.

<ejs-grid [dataSource]='data' [allowRowDragAndDrop]='true'>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, RowDDService} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[RowDDService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

allowSelection boolean

If allowSelection is set to true, it allows selection of (highlight row) Grid records by clicking it.

<ejs-grid [dataSource]='data' [allowSelection]='true'>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

allowSorting boolean

If allowSorting is set to true, it allows sorting of grid records when column header is clicked.

Check the Sorting to customize its default behavior.

<ejs-grid [dataSource]='data' [allowSorting]='true'>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent, SortService} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[SortService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

allowTextWrap boolean

If allowTextWrap set to true,
then text content will wrap to the next line when its text content exceeds the width of the Column Cells.

<ejs-grid [dataSource]='data' [allowTextWrap]='true'>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

autoFit boolean

If autoFit set to true, then it will auto fit the columns based on given width.

childGrid GridModel

Defines Grid options to render child Grid.
It requires the queryString for parent
and child relationship.

Check the Child Grid for its configuration.

clipMode ClipMode

Defines the mode of clip. The available modes are,
Clip: Truncates the cell content when it overflows its area.
Ellipsis: Displays ellipsis when the cell content overflows its area.
EllipsisWithTooltip: Displays ellipsis when the cell content overflows its area,
also it will display the tooltip while hover on ellipsis is applied.

<ejs-grid [dataSource]='data' [clipMode]="Ellipsis">
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderDetails } from './data';
import { GridComponent} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderDetails;
    }
}

columnChooserSettings ColumnChooserSettingsModel

Configures the column chooser in the Grid.

columnMenuItems ColumnMenuItem[]|ColumnMenuItemModel[]

columnMenuItems defines both built-in and custom column menu items.



The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • Filter - Filter options will show based on filterSettings property like checkbox filter, excel filter, menu filter.

columnQueryMode ColumnQueryModeType

columnQueryModeprovides options to retrive data from the datasource.Their types are

  • All: It Retrives whole datasource.
  • Schema: Retrives data for all the defined columns in grid from the datasource.
  • ExcludeHidden: Retrives data only for visible columns of grid from the dataSource.

columns Column[]|string[]|ColumnModel[]

Defines the schema of dataSource.
If the columns declaration is empty or undefined then the columns are automatically generated from data source.

<ejs-grid [dataSource]="data">
    <e-columns>
        <e-column field='CustomerName' headerText='Customer Name' width='150'></e-column>
        <e-column field='Freight' headerText='Freight' width='150' format='C2' textAlign='Right'></e-column>
    </e-columns>
</ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]

contextMenuItems defines both built-in and custom context menu items.



The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • Edit - Edit the current record.
  • Delete - Delete the current record.
  • Save - Save the edited record.
  • Cancel - Cancel the edited state.
  • Copy - Copy the selected records.
  • PdfExport - Export the grid as Pdf format.
  • ExcelExport - Export the grid as Excel format.
  • CsvExport - Export the grid as CSV format.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • FirstPage - Go to the first page.
  • PrevPage - Go to the previous page.
  • LastPage - Go to the last page.
  • NextPage - Go to the next page.

cssClass string

Defines the own class for the grid element.

currentAction ActionArgs

Gets or sets the current action details.

currentViewData Object[]

Gets the currently visible records of the Grid.

dataSource Object|DataManager|DataResult

It is used to render grid table rows.
If the dataSource is an array of JavaScript objects,
then Grid will create instance of DataManager
from this dataSource.
If the dataSource is an existing DataManager,
the Grid will not initialize a new one.

Check the available Adaptors to customize the data operation.

<ejs-grid [dataSource]="data"> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

detailTemplate string|Function

The detail template allows you to show or hide additional information about a particular row.

It accepts either the template string or the HTML element ID.

editSettings EditSettingsModel

Configures the edit settings.

<ejs-grid [dataSource]="data" [editSettings]='editSettings' [toolbar]='toolbar'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent, EditService, ToolbarService, EditSettingsModel,ToolbarItems} from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [EditService, ToolbarService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public editSettings: EditSettingsModel;
    public toolbar: ToolbarItems[];
    public ngOnInit(): void {
        this.data = orderData;
        this.editSettings = { allowEditing: true, allowAdding: true, allowDeleting: true };
        this.toolbar = ['Add', 'Edit', 'Delete', 'Update', 'Cancel'];
    }
}

ej2StatePersistenceVersion string

Defines the version for Grid persistence.

emptyRecordTemplate string|Function

The empty record template that renders customized element or text or image instead of displaying the empty record message in the grid.

It accepts either the template string or the HTML element ID.

enableAdaptiveUI boolean

If enableAdaptiveUI set to true the grid filter, sort, and edit dialogs render adaptively.

enableAltRow boolean

If enableAltRow is set to true, the grid will render with e-altrow CSS class to the alternative tr elements.

Check the AltRow to customize the styles of alternative rows.

<ejs-grid [dataSource]="data" [enableAltRow]="true"> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

enableAutoFill boolean

If enableAutoFill is set to true, then the auto fill icon will displayed on cell selection for copy cells.
It requires the selection mode to be Cell and cellSelectionMode to be Box.

<ejs-grid [dataSource]="data" [enableAutoFill]="true" [selectionSettings]="selectionOptions" > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent,SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public selectionOptions: SelectionSettingsModel;
    public ngOnInit(): void {
        this.data = orderData;
        this.selectionOptions = { cellSelectionMode: 'Box', mode: 'Cell' };
    }
}

enableColumnSpan boolean

Enables or disables column spanning for adjacent cells with similar data.
When enabled, the grid merges adjacent cells with identical data between columns into a single cell, spanning multiple columns to enhance data presentation.

<ejs-grid [dataSource]="data" [enableColumnSpan]="true" > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

enableColumnVirtualization boolean

If enableColumnVirtualization set to true, then the Grid will render only the columns visible within the view-port
and load subsequent columns on horizontal scrolling. This helps to load large dataset of columns in Grid.

<ejs-grid [dataSource]="data" height='300' [enableVirtualization]='true' [enableColumnVirtualization]='true'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent,VirtualScrollService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[VirtualScrollService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

enableHeaderFocus boolean

If enableHeaderFocus set to true, then header element will be focused when focus moves to grid.

enableHover boolean

If enableHover is set to true, the row hover is enabled in the Grid.

<ejs-grid [dataSource]="data" [enableHover]="true" > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

enableHtmlSanitizer boolean

Specifies whether to display or remove the untrusted HTML values in the Grid component.
If ‘enableHtmlSanitizer’ set to true, the component will sanitize any suspected untrusted strings and scripts before rendering them.

enableImmutableMode boolean

If enableImmutableMode is set to true, the grid will reuse old rows if it exists in the new result instead of
full refresh while performing the grid actions.

enableInfiniteScrolling boolean

If enableInfiniteScrolling set to true, then the data will be loaded in Grid when the scrollbar reaches the end.
This helps to load large dataset in Grid.

<ejs-grid [dataSource]="data" height='300' enableInfiniteScrolling='true' > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent,InfiniteScrollService  } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [InfiniteScrollService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

enableRowSpan boolean

Enables or disables row spanning for adjacent cells with similar data.
When enabled, the grid merges adjacent cells with identical data between rows into a single cell, spanning multiple rows to improve readability.

<ejs-grid [dataSource]="data" [enableRowSpan]="true" > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
})
export class AppComponent implements OnInit{
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

enableRtl boolean

Enable or disable rendering component in right to left direction.

enableStickyHeader boolean

If ‘enableStickyHeader’ set to true, then the user can able to make the column headers visible when the document is scrolled.

enableVirtualMaskRow boolean

Specifies the shimmer effect for Grid virtual and infinite scrolling.

enableVirtualization boolean

If enableVirtualization set to true, then the Grid will render only the rows visible within the view-port
and load subsequent rows on vertical scrolling. This helps to load large dataset in Grid.

<ejs-grid [dataSource]="data" height='300' [enableVirtualization]='true'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent,VirtualScrollService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[VirtualScrollService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

exportGrids string[]

Defines the id of the grids that needs to be exported

filterSettings FilterSettingsModel

Configures the filter settings of the Grid.

<ejs-grid [dataSource]="data" [allowFiltering]='true' [filterSettings]='filterOptions' > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent,FilterSettingsModel, FilterService  } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[FilterService]
})
export class AppComponent implements OnInit{
    public data: Object[];
    public filterOptions: FilterSettingsModel;
    public ngOnInit(): void {
        this.data = orderData;
        this.filterOptions = { type: 'Menu'};
    }
}

frozenColumns number

Gets or sets the number of frozen columns.

<ejs-grid [dataSource]="data" [frozenColumns]='1' > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent,FreezeService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[FreezeService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

frozenRows number

Gets or sets the number of frozen rows.

<ejs-grid [dataSource]="data" [frozenRows]='2' > </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GridComponent,FreezeService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers:[FreezeService]
})
export class AppComponent implements OnInit {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

gridLines GridLine

Defines the mode of grid lines. The available modes are,

  • Both: Displays both horizontal and vertical grid lines.
  • None: No grid lines are displayed.
  • Horizontal: Displays the horizontal grid lines only.
  • Vertical: Displays the vertical grid lines only.
  • Default: Displays grid lines based on the theme.
    <ejs-grid [dataSource]='data' gridLines='Both'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

groupSettings GroupSettingsModel

Configures the group settings.

    <ejs-grid [dataSource]='data' [allowGrouping]="true" [groupSettings]="groupOptions">
        <e-columns>
            <e-column field='CustomerName' headerText='Customer Name' width='150'></e-column>
            <e-column field='Freight' headerText='Freight' width='150' format='C2' textAlign='Right'></e-column>
        </e-columns>
    </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { GroupService, GroupSettingsModel } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [GroupService]
})
export class AppComponent {
    public data: Object[];
    public groupOptions: GroupSettingsModel;
    public ngOnInit(): void {
        this.data = orderData;
        this.groupOptions = { columns: ['Freight'] };
    }
}

height string|number

Defines the scrollable height of the grid content.

    <ejs-grid [dataSource]='data' height='400'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

hierarchyPrintMode HierarchyGridPrintMode

Defines the hierarchy grid print modes. The available modes are

  • Expanded - Prints the master grid with expanded child grids.
  • All - Prints the master grid with all the child grids.
  • None - Prints the master grid alone.

infiniteScrollSettings InfiniteScrollSettingsModel

Configures the infinite scroll settings.

    <ejs-grid [dataSource]='data' [enableInfiniteScrolling]='true' [infiniteScrollSettings]='infiniteOptions' [pageSettings]='pageOptions' height:'400'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { InfiniteScrollService, InfiniteScrollSettingsModel, PageSettingsModel } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [InfiniteScrollService]
})
export class AppComponent {
    public data: Object[];
    public pageOptions: PageSettingsModel;
    public infiniteOptions: InfiniteScrollSettingsModel;
    public ngOnInit(): void {
        this.data = orderData;
        this.pageOptions = { pageSize: 50 };
        this.infiniteOptions = { enableCache: true, maxBlocks: 3, initialBlocks: 3 };
    }
}

isRowPinned PinRow|Function

Determines if a row should be pinned at the top. When not set, no rows are pinned.
Pinned rows remain visible across paging, scrolling and other data actions.

isRowSelectable RowSelectable|string

Determines whether a row can be selected.
When not set, all rows are considered selectable.

loadingIndicator LoadingIndicatorModel

Configures the Loading Indicator of the Grid.

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

pageSettings PageSettingsModel

Configures the pager in the Grid.

    <ejs-grid [dataSource]='data' [allowPaging]='true' [pageSettings]='pageOptions'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { PageService, PageSettingsModel } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
     providers: [PageService]
})
export class AppComponent {
    public data: Object[];
    public optiopageOptionsns: PageSettingsModel;
    public ngOnInit(): void {
        this.data = orderData;
        this.pageOptions = { currentPage: 1, pageSize: 12, pageCount: 8, pageSizes: true };
    }
}

pagerTemplate string|Function

It used to render pager template

parentDetails ParentDetails

Gets the parent Grid details.

printMode PrintMode

Defines the print modes. The available print modes are

  • AllPages: Prints all pages of the Grid.
  • CurrentPage: Prints the current page of the Grid.
    <ejs-grid [dataSource]='data' printMode='CurrentPage' [allowPaging]='true' [toolbar]='toolbarOptions'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { PageService, ToolbarService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
     providers: [PageService, ToolbarService]
})
export class AppComponent {
    public data: Object[];
    public toolbarOptions: string[];
    public ngOnInit(): void {
        this.data = orderData;
        this.toolbarOptions = ['Print'];
    }
}

query Query

Defines the external Query
that will be executed along with data processing.

    <ejs-grid [dataSource]='data' [query]='query'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { DataManager, ODataAdaptor, Query } from '@syncfusion/ej2-data';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: DataManager;
    public query: Query;
    public ngOnInit(): void {
        this.data = new DataManager({
            url: 'https://js.syncfusion.com/demos/ejServices/Wcf/Northwind.svc/Orders?$top=7',
            adaptor: new ODataAdaptor()
        });
        this.query = new Query().addParams('ej2grid', 'true');
    }
}

queryString string

Defines the relationship between parent and child datasource. It acts as the foreign key for parent datasource.

resizeSettings ResizeSettingsModel

Defines the resizing behavior of the Grid.

rowDropSettings RowDropSettingsModel

Configures the row drop settings.

rowHeight number

Defines the height of Grid rows.

    <ejs-grid [dataSource]='data' rowHeight='20'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

rowRenderingMode RowRenderingDirection

Defines the grid row elements rendering direction. The available directions are,

  • Horizontal: Renders the grid row elements in the horizontal direction
  • Vertical: Renders the grid row elements in the vertical direction

rowTemplate string|Function

The row template that renders customized rows from the given template.
By default, Grid renders a table row for every data source item.

searchSettings SearchSettingsModel

Configures the search behavior in the Grid.

    <ejs-grid [dataSource]='data' [searchSettings]='searchOptions' [toolbar]='toolbarOptions'>
        <e-columns>
            <e-column field='CustomerName' headerText='Customer Name' width='150'></e-column>
            <e-column field='Freight' headerText='Freight' width='150' format='C2' textAlign='Right'></e-column>
        </e-columns>
    </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { ToolbarService, SearchService, SearchSettingsModel } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
     providers: [ToolbarService, SearchService]
})
export class AppComponent {
    public data: Object[];
    public toolbarOptions: string[];
    public searchOptions: SearchSettingsModel;
    public ngOnInit(): void {
        this.data = orderData;
        this.toolbarOptions = ['Search'];
        this.searchOptions = { fields: ['CustomerName'], key: 'Ha' };
    }
}

selectedRowIndex number

The selectedRowIndex allows you to select a row at initial rendering.
You can also get the currently selected row index.

    <ejs-grid [dataSource]='data' [selectedRowIndex]='5'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

selectionSettings SelectionSettingsModel

Configures the selection settings.

    <ejs-grid [dataSource]='data' [selectionSettings]='selectionOptions'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { SelectionSettingsModel } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: Object[];
    public selectionOptions: SelectionSettingsModel;
    public ngOnInit(): void {
        this.data = orderData;
        this.selectionOptions = { mode: 'Cell', cellSelectionMode: 'Box', type: 'Multiple' };
    }
}

showColumnChooser boolean

If showColumnChooser is set to true, it allows you to dynamically show or hide columns.

Check the ColumnChooser for its configuration.

    <ejs-grid [dataSource]='data' [toolbar]='toolbarOptions' [showColumnChooser]='true'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { ColumnChooserService , ToolbarService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
     providers: [ColumnChooserService, ToolbarService]
})
export class AppComponent {
    public data: Object[];
    public toolbarOptions: string[];
    public ngOnInit(): void {
        this.data = orderData;
        this.toolbarOptions = ['ColumnChooser'];
    }
}

showColumnMenu boolean

If showColumnMenu set to true, then it will enable the column menu options in each columns.

Check the Column menu for its configuration.

    <ejs-grid [dataSource]='data' showColumnMenu='true'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { ColumnMenuService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [ColumnMenuService]
})
export class AppComponent {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

showHider ShowHide

The showHider is used to manipulate column’s show/hide operation in the Grid.

sortSettings SortSettingsModel

Configures the sort settings.

    <ejs-grid [dataSource]='data' [allowSorting]='true' [sortSettings]='sortOptions'>
        <e-columns>
            <e-column field='CustomerName' headerText='Customer Name' width='150'></e-column>
            <e-column field='Freight' headerText='Freight' width='150' format='C2' textAlign='Right'></e-column>
        </e-columns>
    </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { SortService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
    providers: [SortService]
})
export class AppComponent {
    public data: Object[];
    public sortOptions: object;
    public ngOnInit(): void {
        this.data = orderData;
        this.sortOptions = { columns: [{ field: 'CustomerName', direction: 'Ascending' }] };
    }
}

textWrapSettings TextWrapSettingsModel

Configures the text wrap in the Grid.

    <ejs-grid [dataSource]='data' allowTextWrap='true' [textWrapSettings]='wrapOption'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: Object[];
    public wrapOption: Object;
    public ngOnInit(): void {
        this.data = orderData;
        this.wrapOption = { wrapMode: 'Both' };
    }
}

toolbar []

toolbar defines the ToolBar items of the Grid.
It contains built-in and custom toolbar items.
If a string value is assigned to the toolbar option, it is considered as the template for the whole Grid ToolBar.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Grid’s Toolbar.



The available built-in ToolBar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected record.
  • Update: Updates the edited record.
  • Delete: Deletes the selected record.
  • Cancel: Cancels the edit state.
  • Search: Searches records by the given key.
  • Print: Prints the Grid.
  • ExcelExport - Export the Grid to Excel(excelExport() method manually to make export.)
  • PdfExport - Export the Grid to PDF(pdfExport() method manually to make export.)
  • CsvExport - Export the Grid to CSV(csvExport() method manually to make export.)


    The following code example implements the custom toolbar items.

    Check the Toolbar to customize its default items.

    <ejs-grid [dataSource]='data' [toolbar]='toolbarOptions'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
import { ToolbarService } from '@syncfusion/ej2-angular-grids';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html',
     providers: [ToolbarService]
})
export class AppComponent {
    public data: Object[];
    public toolbarOptions: string[];
    public ngOnInit(): void {
        this.data = orderData;
        this.toolbarOptions = ['Search','Print'];
    }
}

toolbarTemplate string|Function

It used to render toolbar template

width string|number

Defines the Grid width.

    <ejs-grid [dataSource]='data' width='700'> </ejs-grid>
import { Component, OnInit } from '@angular/core';
import { orderData } from './data';
@Component({
    selector: 'app-root',
    templateUrl: 'app.component.html'
})
export class AppComponent {
    public data: Object[];
    public ngOnInit(): void {
        this.data = orderData;
    }
}

GridModel

16 Dec 202524 minutes to read

Interface for a class Grid

Properties

actionBegin EmitType< PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc., starts.

import { render, } from 'react-dom';
import React, { Component } from 'react';
import { GridComponent, Page, PageEventArgs, Inject } from '@syncfusion/ej2-react-grids';
import { data } from './dataSource';

export default class App extends React.Component<{}, {}>{
  // For Paging action 
  actionBegin(args: PageEventArgs) {
    alert(args.requestType);
  }
  public render() {
    return (<GridComponent dataSource={data} allowPaging={true} actionBegin={this.actionBegin}>
       <Inject services={[Page]} />
    </GridComponent>
    )
  }
};

actionComplete EmitType< PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc. are completed.

actionFailure EmitType<FailureEventArgs>

Triggers when any Grid action failed to achieve the desired results.

batchAdd EmitType<BatchAddArgs>

Triggers when records are added in batch mode.

batchCancel EmitType<BatchCancelArgs>

Triggers when cancel the batch edit changes batch mode.

batchDelete EmitType<BatchDeleteArgs>

Triggers when records are deleted in batch mode.

beforeAutoFill EmitType<BeforeAutoFillEventArgs>

Triggers before Grid autoFill action.

beforeBatchAdd EmitType<BeforeBatchAddArgs>

Triggers before records are added in batch mode.

beforeBatchDelete EmitType<BeforeBatchDeleteArgs>

Triggers before records are deleted in batch mode.

beforeBatchSave EmitType<BeforeBatchSaveArgs>

Triggers before records are saved in batch mode.

beforeCopy EmitType<BeforeCopyEventArgs>

Triggers before Grid copy action.

beforeCustomFilterOpen EmitType<BeforeCustomFilterOpenEventArgs>

Event triggered before the custom filter dialog is opened.

beforeDataBound EmitType<BeforeDataBoundArgs>

Triggers before data is bound to Grid.

beforeDetailTemplateDetach EmitType<DetailTemplateDetachArgs>

Event triggered before a detail template row is removed from the DOM.
This event allows executing necessary cleanup operations or additional actions before the detail row is detached.

beforeExcelExport EmitType<Object>

Triggers before Grid data is exported to Excel file.

beforeOpenAdaptiveDialog EmitType<AdaptiveDialogEventArgs>

Triggers before adaptive filter and sort dialogs open.

beforeOpenColumnChooser EmitType<ColumnChooserEventArgs>

Triggers before the columnChooser open.

beforePaste EmitType<BeforePasteEventArgs>

Triggers before Grid paste action.

beforePdfExport EmitType<Object>

Triggers before Grid data is exported to PDF document.

beforePrint EmitType<PrintEventArgs>

Triggers before the print action starts.

beginEdit EmitType<BeginEditArgs>

Triggers before the record is to be edit.

cellDeselected EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit EmitType<CellEditArgs>

Triggers when the cell is being edited.

cellSave EmitType<CellSaveArgs>

Triggers when the cell is being saved.

cellSaved EmitType<CellSaveArgs>

Triggers after the cell is saved.

cellSelected EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

checkBoxChange EmitType<CheckBoxChangeEventArgs>

Triggers when the check box state change in checkbox column.

columnDataStateChange EmitType<ColumnDataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done to get column dataSource.
In this event,the current view column data and total record count should be assigned to the column dataSource based
on the action performed.

columnDeselected EmitType<ColumnDeselectEventArgs>

Triggers when a selected column is deselected.

columnDeselecting EmitType<ColumnDeselectEventArgs>

Triggers before deselecting the selected column.

columnDrag EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick EmitType<MenuEventArgs>

Triggers when click on column menu.

columnMenuClose EmitType<ColumnMenuOpenEventArgs>

Triggers before the column menu closes.
This event allows you to perform custom actions or cancel the closing of the column menu.

columnMenuOpen EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

columnSelected EmitType<ColumnSelectEventArgs>

Triggers after a column is selected.

columnSelecting EmitType<ColumnSelectingEventArgs>

Triggers before column selection occurs.

commandClick EmitType<CommandClickEventArgs>

Triggers when command button is clicked.

contextMenuClick EmitType<ContextMenuClickEventArgs>

Triggers when click on context menu.

contextMenuClose EmitType<ContextMenuOpenEventArgs>

Triggers before the context menu closes.
This event allows you to perform custom actions or cancel the closing of the context menu.

contextMenuOpen EmitType<ContextMenuOpenEventArgs>

Triggers before context menu opens.

created EmitType<Object>

Triggers when the component is created.

dataBound EmitType<Object>

Triggers when data source is populated in the Grid.

dataSourceChanged EmitType<DataSourceChangedEventArgs>

Triggers when the grid data is added, deleted and updated.
Invoke the done method from the argument to start render after edit operation.

dataStateChange EmitType<DataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done.
In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed EmitType<Object>

Triggers when the component is destroyed.

detailCollapse EmitType<DetailExpandCollapseArgs>

Triggers before collapsing the detail row.
This event allows to perform customize actions or cancel the collapse of the detail row.

detailDataBound EmitType<DetailDataBoundEventArgs>

Triggers after detail row expands.

This event triggers at initial expand.

detailExpand EmitType<DetailExpandCollapseArgs>

Triggers before expanding the detail row.
This event allows to perform customize actions or cancel the expansion of the detail row.

excelAggregateQueryCellInfo EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to Excel document. You can also customize the PDF cells.

excelExportComplete EmitType<ExcelExportCompleteArgs>

Triggers after Grid data is exported to Excel file.

excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file.
You can also customize the Excel cells.

excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file.
You can also customize the Excel cells.

exportDetailDataBound EmitType<ExportDetailDataBoundEventArgs>

Triggers before exporting each detail Grid to PDF document.

exportDetailTemplate EmitType<ExportDetailTemplateEventArgs>

Triggers before exporting each detail template.

exportGroupCaption EmitType<ExportGroupCaptionEventArgs>

Triggers before exporting each caption row to PDF/Excel/CSV document. You can also customize the export caption row values.

headerCellInfo EmitType<HeaderCellInfoEventArgs>

Triggered for stacked header.

keyPressed EmitType<KeyboardEventArgs>

Triggers when any keyboard keys are pressed inside the grid.

lazyLoadGroupCollapse EmitType<LazyLoadArgs>

Triggers when collapse the caption row in lazy load grouping.

lazyLoadGroupExpand EmitType<LazyLoadArgs>

Triggers when expand the caption row in lazy load grouping.

load EmitType<Object>

This event allows customization of Grid properties before rendering.

pdfAggregateQueryCellInfo EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to PDF document. You can also customize the PDF cells.

pdfExportComplete EmitType<PdfExportCompleteArgs>

Triggers after Grid data is exported to PDF document.

pdfHeaderQueryCellInfo EmitType<PdfHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

printComplete EmitType<PrintEventArgs>

Triggers after print action is completed.

queryCellInfo EmitType<QueryCellInfoEventArgs>

Triggered every time a request is made to access cell information, element, or data.
This will be triggered before the cell element is appended to the Grid element.

recordClick EmitType<RecordClickEventArgs>

Triggers when record is clicked.

recordDoubleClick EmitType<RecordDoubleClickEventArgs>

Triggers when record is double clicked.

resizeStart EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop EmitType<ResizeArgs>

Triggers when column resize ends.

resizing EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound EmitType<RowDataBoundEventArgs>

Triggered every time a request is made to access row information, element, or data.
This will be triggered before the row element is appended to the Grid element.

rowDeselected EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting EmitType<RowDeselectingEventArgs>

Triggers before deselecting the selected row.

rowDrag EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected EmitType<RowSelectEventArgs>

Triggers after a row is selected.

rowSelecting EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

toolbarClick EmitType<ClickEventArgs>

Triggers when toolbar item is clicked.

adaptiveUIMode AdaptiveMode

One of the adaptiveUIMode enumeration that specifies the Adaptive Mode. The default value is Both.

aggregates AggregateRowModel[]

Configures the Grid aggregate rows.

import { AggregateColumnDirective, ColumnDirective, ColumnsDirective, GridComponent, Inject,AggregateColumnsDirective, AggregateDirective, AggregatesDirective, Aggregate } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public footerSum(props: any) : any {
    return(<span>Sum: {props.Sum}</span>)
  }
  public render(){
      return <GridComponent  dataSource={data}>
                <ColumnsDirective>
                  <ColumnDirective field='OrderID' headerText='Order ID' textAlign='Right'/>
                  <ColumnDirective field='Freight' headerText='Freight' textAlign='Right'/>
              </ColumnsDirective>
              <AggregatesDirective>
                <AggregateDirective>
                  <AggregateColumnsDirective>
                    <AggregateColumnDirective field='Freight' type='Sum' footerTemplate={this.footerSum} />
                  </AggregateColumnsDirective>
                </AggregateDirective>
              </AggregatesDirective>
              <Inject services={[Aggregate]}/>
          </GridComponent>
      } }

Check the Aggregates for its configuration.

allowExcelExport boolean

If allowExcelExport set to true, then it will allow the user to export grid to Excel file.

Check the ExcelExport to configure exporting document.

import { ExcelExport, Grid, Inject, Toolbar, GridComponent, ToolbarItems } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}> {
  public toolbar: ToolbarItems[] = ['ExcelExport'];
  public render() {
    return (
        <GridComponent dataSource={data} toolbar={this.toolbar} allowExcelExport={true} >
        <Inject services={[Toolbar, ExcelExport]}/>
      </GridComponent>
    ); } }

allowFiltering boolean

If allowFiltering set to true the filter bar will be displayed.
If set to false the filter bar will not be displayed.
Filter bar allows the user to filter grid records with required criteria.

Check the Filtering to customize its default behavior.

import { Filter, GridComponent, Inject } from '@syncfusion/ej2-react-grids'
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
    return <GridComponent dataSource={data} allowFiltering={true}>
        <Inject services={[Filter]} />
    </GridComponent>
  }
};

allowGrouping boolean

If allowGrouping set to true, then it will allow the user to dynamically group or ungroup columns.
Grouping can be done by drag and drop columns from column header to group drop area.

Check the Grouping to customize its default behavior.

import { GridComponent, Group, Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowGrouping={true}>
            <Inject services={[Group]}/>
        </GridComponent >
    }
};

allowKeyboard boolean

Enables or disables the key board interaction of Grid.

allowMultiSorting boolean

If allowMultiSorting set to true, then it will allow the user to sort multiple column in the grid.

allowSorting should be true.

import { GridComponent, Sort, Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowSorting={true} allowMultiSorting={true}>
            <Inject services={[Sort]}/>
        </GridComponent >
    }
};

allowPaging boolean

If allowPaging is set to true, the pager renders at the footer of the Grid. It is used to handle page navigation in the Grid.

Check the Paging to configure the grid pager.

allowPdfExport boolean

If allowPdfExport set to true, then it will allow the user to export grid to Pdf file.

Check the Pdfexport to configure the exporting document.

import { PdfExport, Grid, Inject, Toolbar, GridComponent, ToolbarItems } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}> {
  public toolbar: ToolbarItems[] = ['PdfExport'];
  public render() {
    return (
        <GridComponent dataSource={data} toolbar={this.toolbar} allowPdfExport={true} >
        <Inject services={[Toolbar, PdfExport]}/>
      </GridComponent>
    ); } }

allowReordering boolean

If allowReordering is set to true, Grid columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.

If Grid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.

import { GridComponent, Reorder, Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowReordering={true}>
            <Inject services={[Reorder]}/>
        </GridComponent >
    }  };

allowResizing boolean

If allowResizing is set to true, Grid columns can be resized.

import { GridComponent, Resize , Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowResizing={true}>
            <Inject services={[Resize ]}/>
        </GridComponent >
    }  };

allowRowDragAndDrop boolean

If allowRowDragAndDrop is set to true, you can drag and drop grid rows at another grid.

import { GridComponent, RowDD , Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowRowDragAndDrop={true}>
            <Inject services={[RowDD]}/>
        </GridComponent >
    }  };

allowSelection boolean

If allowSelection is set to true, it allows selection of (highlight row) Grid records by clicking it.

import { GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowSelection={true}/>
    }  };

allowSorting boolean

If allowSorting is set to true, it allows sorting of grid records when column header is clicked.

Check the Sorting to customize its default behavior.

import { GridComponent, Sort, Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowSorting={true}>
            <Inject services={[Sort]}/>
        </GridComponent >
    }
};

allowTextWrap boolean

If allowTextWrap set to true,
then text content will wrap to the next line when its text content exceeds the width of the Column Cells.

import { GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} allowTextWrap={true}/>
    }  };

autoFit boolean

If autoFit set to true, then it will auto fit the columns based on given width.

childGrid GridModel

Defines Grid options to render child Grid.
It requires the queryString for parent
and child relationship.

Check the Child Grid for its configuration.

clipMode ClipMode

Defines the mode of clip. The available modes are,
Clip: Truncates the cell content when it overflows its area.
Ellipsis: Displays ellipsis when the cell content overflows its area.
EllipsisWithTooltip: Displays ellipsis when the cell content overflows its area,
also it will display the tooltip while hover on ellipsis is applied.

import { ColumnDirective, ColumnsDirective, GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { inventoryData } from './datasource';

export default class App extends React.Component<{}, {}>{
  public render() {
    return (
    <GridComponent dataSource={inventoryData}>
        <ColumnsDirective>
            <ColumnDirective field='Inventor' headerText='Name of the Inventor' clipMode='Clip' />
            <ColumnDirective field='NumberofPatentFamilies' headerText='Number of Patent Families' clipMode='Ellipsis' />
        </ColumnsDirective>
    </GridComponent> 
    ) } };

columnChooserSettings ColumnChooserSettingsModel

Configures the column chooser in the Grid.

columnMenuItems ColumnMenuItem[]|ColumnMenuItemModel[]

columnMenuItems defines both built-in and custom column menu items.



The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • Filter - Filter options will show based on filterSettings property like checkbox filter, excel filter, menu filter.

columnQueryMode ColumnQueryModeType

columnQueryModeprovides options to retrive data from the datasource.Their types are

  • All: It Retrives whole datasource.
  • Schema: Retrives data for all the defined columns in grid from the datasource.
  • ExcludeHidden: Retrives data only for visible columns of grid from the dataSource.

columns Column[]|string[]|ColumnModel[]

Defines the schema of dataSource.
If the columns declaration is empty or undefined then the columns are automatically generated from data source.

import { ColumnDirective, ColumnsDirective, GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { inventoryData } from './datasource';

export default class App extends React.Component<{}, {}>{
  public render() {
    return (
    <GridComponent dataSource={inventoryData}>
        <ColumnsDirective>
            <ColumnDirective field='Inventor' headerText='Name of the Inventor'/>
            <ColumnDirective field='NumberofPatentFamilies' headerText='Number of Patent Families' />
        </ColumnsDirective>
    </GridComponent> 
    ) } };

contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]

contextMenuItems defines both built-in and custom context menu items.



The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • Edit - Edit the current record.
  • Delete - Delete the current record.
  • Save - Save the edited record.
  • Cancel - Cancel the edited state.
  • Copy - Copy the selected records.
  • PdfExport - Export the grid as Pdf format.
  • ExcelExport - Export the grid as Excel format.
  • CsvExport - Export the grid as CSV format.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • FirstPage - Go to the first page.
  • PrevPage - Go to the previous page.
  • LastPage - Go to the last page.
  • NextPage - Go to the next page.

cssClass string

Defines the own class for the grid element.

currentAction ActionArgs

Gets or sets the current action details.

currentViewData Object[]

Gets the currently visible records of the Grid.

dataSource Object|DataManager|DataResult

It is used to render grid table rows.
If the dataSource is an array of JavaScript objects,
then Grid will create instance of DataManager
from this dataSource.
If the dataSource is an existing DataManager,
the Grid will not initialize a new one.

Check the available Adaptors to customize the data operation.

import {GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
    return (
    <GridComponent dataSource={data} /> 
    ) } };

detailTemplate string|Function

The detail template allows you to show or hide additional information about a particular row.

It accepts either the template string or the HTML element ID.

editSettings EditSettingsModel

Configures the edit settings.

import { Edit, EditSettingsModel, Inject, GridComponent,Toolbar,ToolbarItems} from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}> {
  public editOptions: EditSettingsModel = { allowEditing: true, allowAdding: true, allowDeleting: true };
   public toolbarOptions: ToolbarItems[] = ['Add', "Delete", "Edit"];
  public render() {
    return <GridComponent dataSource={data} editSettings={this.editOptions} toolbar={this.toolbarOptions} >
        <Inject services={[Edit,Toolbar]} />
    </GridComponent>
  } }

ej2StatePersistenceVersion string

Defines the version for Grid persistence.

emptyRecordTemplate string|Function

The empty record template that renders customized element or text or image instead of displaying the empty record message in the grid.

It accepts either the template string or the HTML element ID.

enableAdaptiveUI boolean

If enableAdaptiveUI set to true the grid filter, sort, and edit dialogs render adaptively.

enableAltRow boolean

If enableAltRow is set to true, the grid will render with e-altrow CSS class to the alternative tr elements.

Check the AltRow to customize the styles of alternative rows.

import {GridComponent} from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
    return <GridComponent dataSource={data} enableAltRow={false} /> 
     } };

enableAutoFill boolean

If enableAutoFill is set to true, then the auto fill icon will displayed on cell selection for copy cells.
It requires the selection mode to be Cell and cellSelectionMode to be Box.

import {GridComponent, SelectionSettingsModel } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public settings: SelectionSettingsModel = { cellSelectionMode: 'Box', mode: 'Cell'};
  public render() {
    return <GridComponent dataSource={data} enableAutoFill={true} selectionSettings={this.settings} />  
     } };

enableColumnSpan boolean

Enables or disables column spanning for adjacent cells with similar data.
When enabled, the grid merges adjacent cells with identical data between columns into a single cell, spanning multiple columns to enhance data presentation.

import {GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
    return <GridComponent dataSource={data} enableColumnSpan={true} />  
     } };

enableColumnVirtualization boolean

If enableColumnVirtualization set to true, then the Grid will render only the columns visible within the view-port
and load subsequent columns on horizontal scrolling. This helps to load large dataset of columns in Grid.

import { GridComponent, VirtualScroll, Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} height={300} enableVirtualization={true} enableColumnVirtualization={true}>
            <Inject services={[VirtualScroll]}/>
        </GridComponent >
    }  };

enableHeaderFocus boolean

If enableHeaderFocus set to true, then header element will be focused when focus moves to grid.

enableHover boolean

If enableHover is set to true, the row hover is enabled in the Grid.

import {GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
    return <GridComponent dataSource={data} enableHover={true} />  
     } };

enableHtmlSanitizer boolean

Specifies whether to display or remove the untrusted HTML values in the Grid component.
If ‘enableHtmlSanitizer’ set to true, the component will sanitize any suspected untrusted strings and scripts before rendering them.

enableImmutableMode boolean

If enableImmutableMode is set to true, the grid will reuse old rows if it exists in the new result instead of
full refresh while performing the grid actions.

enableInfiniteScrolling boolean

If enableInfiniteScrolling set to true, then the data will be loaded in Grid when the scrollbar reaches the end.
This helps to load large dataset in Grid.

import { GridComponent, InfiniteScroll, Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} height={300} enableInfiniteScrolling={true}>
            <Inject services={[InfiniteScroll]}/>
        </GridComponent >
    } };

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

enableRowSpan boolean

Enables or disables row spanning for adjacent cells with similar data.
When enabled, the grid merges adjacent cells with identical data between rows into a single cell, spanning multiple rows to improve readability.

import {GridComponent } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
    return <GridComponent dataSource={data} enableRowSpan={true} />  
     } };

enableRtl boolean

Enable or disable rendering component in right to left direction.

enableStickyHeader boolean

If ‘enableStickyHeader’ set to true, then the user can able to make the column headers visible when the document is scrolled.

enableVirtualMaskRow boolean

Specifies the shimmer effect for Grid virtual and infinite scrolling.

enableVirtualization boolean

If enableVirtualization set to true, then the Grid will render only the rows visible within the view-port
and load subsequent rows on vertical scrolling. This helps to load large dataset in Grid.

import { GridComponent, VirtualScroll, Inject } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render(){
    return <GridComponent  dataSource={data} height={300} enableVirtualization={true}>
            <Inject services={[VirtualScroll]}/>
        </GridComponent >
    }  };

exportGrids string[]

Defines the id of the grids that needs to be exported

filterSettings FilterSettingsModel

Configures the filter settings of the Grid.

import { Filter, FilterSettingsModel, GridComponent, Inject } from '@syncfusion/ej2-react-grids'
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public FilterOptions: FilterSettingsModel = { type: 'Menu' };
  public render() {
      return <GridComponent dataSource={data} filterSettings={this.FilterOptions} allowFiltering={true} >
          <Inject services={[Filter]} />
      </GridComponent>
  } };

frozenColumns number

Gets or sets the number of frozen columns.

import { Freeze, FilterSettingsModel, GridComponent, Inject } from '@syncfusion/ej2-react-grids'
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
      return <GridComponent dataSource={data} frozenColumns={1} >
          <Inject services={[Freeze]} />
      </GridComponent>
  } };

frozenRows number

Gets or sets the number of frozen rows.

import { Freeze, FilterSettingsModel, GridComponent, Inject } from '@syncfusion/ej2-react-grids'
import * as React from 'react';
import { data } from './datasource';
export default class App extends React.Component<{}, {}>{
  public render() {
      return <GridComponent dataSource={data} frozenRows={1} >
          <Inject services={[Freeze]} />
      </GridComponent>
  } };

gridLines GridLine

Defines the mode of grid lines. The available modes are,

  • Both: Displays both horizontal and vertical grid lines.
  • None: No grid lines are displayed.
  • Horizontal: Displays the horizontal grid lines only.
  • Vertical: Displays the vertical grid lines only.
  • Default: Displays grid lines based on the theme.
import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (<GridComponent dataSource={data} gridLines='Both' />);
    }
}

groupSettings GroupSettingsModel

Configures the group settings.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, ColumnsDirective, ColumnDirective, Group, Inject } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (
          <GridComponent dataSource={data} allowGrouping={true} groupSettings={{ columns: ['Freight'] }}>
            <ColumnsDirective>
              <ColumnDirective field='CustomerName' headerText='Customer Name' width='150'></ColumnDirective>
              <ColumnDirective field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'></ColumnDirective>
            </ColumnsDirective>
            <Inject services={[Group]}/>
          </GridComponent>);
    }
}

height string|number

Defines the scrollable height of the grid content.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (<GridComponent dataSource={data} height="400" />);
    }
}

hierarchyPrintMode HierarchyGridPrintMode

Defines the hierarchy grid print modes. The available modes are

  • Expanded - Prints the master grid with expanded child grids.
  • All - Prints the master grid with all the child grids.
  • None - Prints the master grid alone.

infiniteScrollSettings InfiniteScrollSettingsModel

Configures the infinite scroll settings.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, Inject, InfiniteScroll, InfiniteScrollSettingsModel } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public infiniteOptions: InfiniteScrollSettingsModel = { enableCache: true, maxBlocks: 3, initialBlocks: 3 };
    public render() {
        return (
          <GridComponent dataSource={data} height="300" enableInfiniteScrolling={true} infiniteScrollSettings={ this.infiniteOptions } pageSettings={ { pageSize: 50 } }>
            <Inject services={[InfiniteScroll]}/>
          </GridComponent>);
    }
}

isRowPinned PinRow|Function

Determines if a row should be pinned at the top. When not set, no rows are pinned.
Pinned rows remain visible across paging, scrolling and other data actions.

isRowSelectable RowSelectable|string

Determines whether a row can be selected.
When not set, all rows are considered selectable.

loadingIndicator LoadingIndicatorModel

Configures the Loading Indicator of the Grid.

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

pageSettings PageSettingsModel

Configures the pager in the Grid.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, Inject, Page, PageSettingsModel } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public pageOptions: PageSettingsModel = { currentPage: 1, pageSize: 12, pageCount: 8, pageSizes: true };
    public render() {
        return (
          <GridComponent dataSource={data} allowPaging={true} pageSettings={this.pageOptions}>
            <Inject services={[Page]}/>
          </GridComponent>);
    }
}

pagerTemplate string|Function

It used to render pager template

parentDetails ParentDetails

Gets the parent Grid details.

printMode PrintMode

Defines the print modes. The available print modes are

  • AllPages: Prints all pages of the Grid.
  • CurrentPage: Prints the current page of the Grid.
import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, Inject, Page, Toolbar } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (
          <GridComponent dataSource={data} printMode='CurrentPage' toolbar={['Print']} allowPaging={true}>
           <Inject services={[Page, Toolbar]}/>
          </GridComponent>);
    }
}

query Query

Defines the external Query
that will be executed along with data processing.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent } from '@syncfusion/ej2-react-grids';
import { DataManager, ODataAdaptor, Query } from '@syncfusion/ej2-data';

export default class App extends React.Component<{}, {}> {
    public data = new DataManager({
        adaptor: new ODataAdaptor,
        url: 'https://js.syncfusion.com/demos/ejServices/Wcf/Northwind.svc/Orders/'
    });
    public query = new Query().addParams('ej2grid', 'true');
    public render() {
        return (<GridComponent dataSource={data} query={this.query} />);
    }
}

queryString string

Defines the relationship between parent and child datasource. It acts as the foreign key for parent datasource.

resizeSettings ResizeSettingsModel

Defines the resizing behavior of the Grid.

rowDropSettings RowDropSettingsModel

Configures the row drop settings.

rowHeight number

Defines the height of Grid rows.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (<GridComponent dataSource={data} rowHeight="20" />);
    }
}

rowRenderingMode RowRenderingDirection

Defines the grid row elements rendering direction. The available directions are,

  • Horizontal: Renders the grid row elements in the horizontal direction
  • Vertical: Renders the grid row elements in the vertical direction

rowTemplate string|Function

The row template that renders customized rows from the given template.
By default, Grid renders a table row for every data source item.

searchSettings SearchSettingsModel

Configures the search behavior in the Grid.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, ColumnsDirective, ColumnDirective, Inject, SearchSettingsModel } from '@syncfusion/ej2-react-grids';
import { Page, Toolbar, Search } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public searchOptions: SearchSettingsModel = { fields: ['CustomerName'], key: 'Ha' };
    public render() {
        return (
          <GridComponent dataSource={data} toolbar={['Search']}  searchSettings={this.searchOptions}>
            <ColumnsDirective>
              <ColumnDirective field='CustomerName' headerText='Customer Name' width='150'></ColumnDirective>
              <ColumnDirective field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'></ColumnDirective>
            </ColumnsDirective>
            <Inject services={[Search, Toolbar]}/>
          </GridComponent>);
    }
}

selectedRowIndex number

The selectedRowIndex allows you to select a row at initial rendering.
You can also get the currently selected row index.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (<GridComponent dataSource={data} selectedRowIndex={5} />);
    }
}

selectionSettings SelectionSettingsModel

Configures the selection settings.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, SelectionSettingsModel } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public selectionOptions: SelectionSettingsModel = { mode: 'Cell', cellSelectionMode: 'Box', type: 'Multiple' };
    public render() {
        return (<GridComponent dataSource={data}  selectionSettings={this.selectionOptions} />);
    }
}

showColumnChooser boolean

If showColumnChooser is set to true, it allows you to dynamically show or hide columns.

Check the ColumnChooser for its configuration.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, Inject, ColumnChooser, Toolbar } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (
          <GridComponent dataSource={data} toolbar={['ColumnChooser']} showColumnChooser={true}>
            <Inject services={[ColumnChooser, Toolbar]}/>
          </GridComponent>);
    }
}

showColumnMenu boolean

If showColumnMenu set to true, then it will enable the column menu options in each columns.

Check the Column menu for its configuration.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, ColumnMenu } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (
          <GridComponent dataSource={data} showColumnMenu={true}>
             <Inject services={[ColumnMenu]} />
          </GridComponent>);
    }
}

showHider ShowHide

The showHider is used to manipulate column’s show/hide operation in the Grid.

sortSettings SortSettingsModel

Configures the sort settings.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, ColumnsDirective, ColumnDirective, Inject, Sort, SortSettingsModel } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public sortingOptions: SortSettingsModel = { columns: [{ field: 'CustomerName', direction: 'Ascending' }] };
    public render() {
        return (
          <GridComponent dataSource={data} allowSorting={true} sortSettings={this.sortingOptions}>
            <ColumnsDirective>
              <ColumnDirective field='CustomerName' headerText='Customer Name' width='150'></ColumnDirective>
              <ColumnDirective field='Freight' headerText='Freight' width='120' format='C2' textAlign='Right'></ColumnDirective>
            </ColumnsDirective>
            <Inject services={[Sort]} />
          </GridComponent>);
    }
}

textWrapSettings TextWrapSettingsModel

Configures the text wrap in the Grid.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (<GridComponent dataSource={data}  allowTextWrap={true} textWrapSettings={{ wrapMode: 'Both' }}/>);
    }
}

toolbar []

toolbar defines the ToolBar items of the Grid.
It contains built-in and custom toolbar items.
If a string value is assigned to the toolbar option, it is considered as the template for the whole Grid ToolBar.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Grid’s Toolbar.



The available built-in ToolBar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected record.
  • Update: Updates the edited record.
  • Delete: Deletes the selected record.
  • Cancel: Cancels the edit state.
  • Search: Searches records by the given key.
  • Print: Prints the Grid.
  • ExcelExport - Export the Grid to Excel(excelExport() method manually to make export.)
  • PdfExport - Export the Grid to PDF(pdfExport() method manually to make export.)
  • CsvExport - Export the Grid to CSV(csvExport() method manually to make export.)


    The following code example implements the custom toolbar items.

    Check the Toolbar to customize its default items.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent, Inject, Toolbar } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return (
          <GridComponent dataSource={data} toolbar={['Search','Print']}>
            <Inject services={[Toolbar]}/>
          </GridComponent>);
    }
}

toolbarTemplate string|Function

It used to render toolbar template

width string|number

Defines the Grid width.

import { render } from 'react-dom';
import * as React from 'react';
import { GridComponent } from '@syncfusion/ej2-react-grids';
import { data } from './data';

export default class App extends React.Component<{}, {}> {
    public render() {
        return ( <GridComponent dataSource={data} width="700" />);
    }
}

GridModel

16 Dec 202524 minutes to read

Interface for a class Grid

Properties

actionBegin EmitType< PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc., starts.

<template>
  <div id="app">
    <ejs-grid :dataSource="data" allowPaging="true" :actionBegin="actionBegin"></ejs-grid>
  </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";

Vue.use(GridPlugin);

export default {
  data() {
    return {
      data: data
    };
  },
  methods: {
    actionBegin: args => {
      console.log(args.requestType);
    }
  },
  provide: {
    grid: [Page]
  }
};
</script>

actionComplete EmitType< PageEventArgs|GroupEventArgs|FilterEventArgs|SearchEventArgs|SortEventArgs|AddEventArgs|SaveEventArgs|EditEventArgs|DeleteEventArgs|ActionEventArgs|NotifyArgs|ReorderEventArgs>

Triggers when Grid actions such as sorting, filtering, paging, grouping etc. are completed.

actionFailure EmitType<FailureEventArgs>

Triggers when any Grid action failed to achieve the desired results.

batchAdd EmitType<BatchAddArgs>

Triggers when records are added in batch mode.

batchCancel EmitType<BatchCancelArgs>

Triggers when cancel the batch edit changes batch mode.

batchDelete EmitType<BatchDeleteArgs>

Triggers when records are deleted in batch mode.

beforeAutoFill EmitType<BeforeAutoFillEventArgs>

Triggers before Grid autoFill action.

beforeBatchAdd EmitType<BeforeBatchAddArgs>

Triggers before records are added in batch mode.

beforeBatchDelete EmitType<BeforeBatchDeleteArgs>

Triggers before records are deleted in batch mode.

beforeBatchSave EmitType<BeforeBatchSaveArgs>

Triggers before records are saved in batch mode.

beforeCopy EmitType<BeforeCopyEventArgs>

Triggers before Grid copy action.

beforeCustomFilterOpen EmitType<BeforeCustomFilterOpenEventArgs>

Event triggered before the custom filter dialog is opened.

beforeDataBound EmitType<BeforeDataBoundArgs>

Triggers before data is bound to Grid.

beforeDetailTemplateDetach EmitType<DetailTemplateDetachArgs>

Event triggered before a detail template row is removed from the DOM.
This event allows executing necessary cleanup operations or additional actions before the detail row is detached.

beforeExcelExport EmitType<Object>

Triggers before Grid data is exported to Excel file.

beforeOpenAdaptiveDialog EmitType<AdaptiveDialogEventArgs>

Triggers before adaptive filter and sort dialogs open.

beforeOpenColumnChooser EmitType<ColumnChooserEventArgs>

Triggers before the columnChooser open.

beforePaste EmitType<BeforePasteEventArgs>

Triggers before Grid paste action.

beforePdfExport EmitType<Object>

Triggers before Grid data is exported to PDF document.

beforePrint EmitType<PrintEventArgs>

Triggers before the print action starts.

beginEdit EmitType<BeginEditArgs>

Triggers before the record is to be edit.

cellDeselected EmitType<CellDeselectEventArgs>

Triggers when a particular selected cell is deselected.

cellDeselecting EmitType<CellDeselectEventArgs>

Triggers before the selected cell is deselecting.

cellEdit EmitType<CellEditArgs>

Triggers when the cell is being edited.

cellSave EmitType<CellSaveArgs>

Triggers when the cell is being saved.

cellSaved EmitType<CellSaveArgs>

Triggers after the cell is saved.

cellSelected EmitType<CellSelectEventArgs>

Triggers after a cell is selected.

cellSelecting EmitType<CellSelectingEventArgs>

Triggers before any cell selection occurs.

checkBoxChange EmitType<CheckBoxChangeEventArgs>

Triggers when the check box state change in checkbox column.

columnDataStateChange EmitType<ColumnDataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done to get column dataSource.
In this event,the current view column data and total record count should be assigned to the column dataSource based
on the action performed.

columnDeselected EmitType<ColumnDeselectEventArgs>

Triggers when a selected column is deselected.

columnDeselecting EmitType<ColumnDeselectEventArgs>

Triggers before deselecting the selected column.

columnDrag EmitType<ColumnDragEventArgs>

Triggers when column header element is dragged (moved) continuously.

columnDragStart EmitType<ColumnDragEventArgs>

Triggers when column header element drag (move) starts.

columnDrop EmitType<ColumnDragEventArgs>

Triggers when a column header element is dropped on the target column.

columnMenuClick EmitType<MenuEventArgs>

Triggers when click on column menu.

columnMenuClose EmitType<ColumnMenuOpenEventArgs>

Triggers before the column menu closes.
This event allows you to perform custom actions or cancel the closing of the column menu.

columnMenuOpen EmitType<ColumnMenuOpenEventArgs>

Triggers before column menu opens.

columnSelected EmitType<ColumnSelectEventArgs>

Triggers after a column is selected.

columnSelecting EmitType<ColumnSelectingEventArgs>

Triggers before column selection occurs.

commandClick EmitType<CommandClickEventArgs>

Triggers when command button is clicked.

contextMenuClick EmitType<ContextMenuClickEventArgs>

Triggers when click on context menu.

contextMenuClose EmitType<ContextMenuOpenEventArgs>

Triggers before the context menu closes.
This event allows you to perform custom actions or cancel the closing of the context menu.

contextMenuOpen EmitType<ContextMenuOpenEventArgs>

Triggers before context menu opens.

created EmitType<Object>

Triggers when the component is created.

dataBound EmitType<Object>

Triggers when data source is populated in the Grid.

dataSourceChanged EmitType<DataSourceChangedEventArgs>

Triggers when the grid data is added, deleted and updated.
Invoke the done method from the argument to start render after edit operation.

dataStateChange EmitType<DataStateChangeEventArgs>

Triggers when the grid actions such as Sorting, Paging, Grouping etc., are done.
In this event,the current view data and total record count should be assigned to the dataSource based on the action performed.

destroyed EmitType<Object>

Triggers when the component is destroyed.

detailCollapse EmitType<DetailExpandCollapseArgs>

Triggers before collapsing the detail row.
This event allows to perform customize actions or cancel the collapse of the detail row.

detailDataBound EmitType<DetailDataBoundEventArgs>

Triggers after detail row expands.

This event triggers at initial expand.

detailExpand EmitType<DetailExpandCollapseArgs>

Triggers before expanding the detail row.
This event allows to perform customize actions or cancel the expansion of the detail row.

excelAggregateQueryCellInfo EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to Excel document. You can also customize the PDF cells.

excelExportComplete EmitType<ExcelExportCompleteArgs>

Triggers after Grid data is exported to Excel file.

excelHeaderQueryCellInfo EmitType<ExcelHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to Excel file.
You can also customize the Excel cells.

excelQueryCellInfo EmitType<ExcelQueryCellInfoEventArgs>

Triggers before exporting each cell to Excel file.
You can also customize the Excel cells.

exportDetailDataBound EmitType<ExportDetailDataBoundEventArgs>

Triggers before exporting each detail Grid to PDF document.

exportDetailTemplate EmitType<ExportDetailTemplateEventArgs>

Triggers before exporting each detail template.

exportGroupCaption EmitType<ExportGroupCaptionEventArgs>

Triggers before exporting each caption row to PDF/Excel/CSV document. You can also customize the export caption row values.

headerCellInfo EmitType<HeaderCellInfoEventArgs>

Triggered for stacked header.

keyPressed EmitType<KeyboardEventArgs>

Triggers when any keyboard keys are pressed inside the grid.

lazyLoadGroupCollapse EmitType<LazyLoadArgs>

Triggers when collapse the caption row in lazy load grouping.

lazyLoadGroupExpand EmitType<LazyLoadArgs>

Triggers when expand the caption row in lazy load grouping.

load EmitType<Object>

This event allows customization of Grid properties before rendering.

pdfAggregateQueryCellInfo EmitType<AggregateQueryCellInfoEventArgs>

Triggers before exporting aggregate cell to PDF document. You can also customize the PDF cells.

pdfExportComplete EmitType<PdfExportCompleteArgs>

Triggers after Grid data is exported to PDF document.

pdfHeaderQueryCellInfo EmitType<PdfHeaderQueryCellInfoEventArgs>

Triggers before exporting each header cell to PDF document. You can also customize the PDF cells.

pdfQueryCellInfo EmitType<PdfQueryCellInfoEventArgs>

Triggers before exporting each cell to PDF document. You can also customize the PDF cells.

printComplete EmitType<PrintEventArgs>

Triggers after print action is completed.

queryCellInfo EmitType<QueryCellInfoEventArgs>

Triggered every time a request is made to access cell information, element, or data.
This will be triggered before the cell element is appended to the Grid element.

recordClick EmitType<RecordClickEventArgs>

Triggers when record is clicked.

recordDoubleClick EmitType<RecordDoubleClickEventArgs>

Triggers when record is double clicked.

resizeStart EmitType<ResizeArgs>

Triggers when column resize starts.

resizeStop EmitType<ResizeArgs>

Triggers when column resize ends.

resizing EmitType<ResizeArgs>

Triggers on column resizing.

rowDataBound EmitType<RowDataBoundEventArgs>

Triggered every time a request is made to access row information, element, or data.
This will be triggered before the row element is appended to the Grid element.

rowDeselected EmitType<RowDeselectEventArgs>

Triggers when a selected row is deselected.

rowDeselecting EmitType<RowDeselectingEventArgs>

Triggers before deselecting the selected row.

rowDrag EmitType<RowDragEventArgs>

Triggers when row elements are dragged (moved) continuously.

rowDragStart EmitType<RowDragEventArgs>

Triggers when row element’s drag(move) starts.

rowDragStartHelper EmitType<RowDragEventArgs>

Triggers when row element’s before drag(move).

rowDrop EmitType<RowDragEventArgs>

Triggers when row elements are dropped on the target row.

rowSelected EmitType<RowSelectEventArgs>

Triggers after a row is selected.

rowSelecting EmitType<RowSelectingEventArgs>

Triggers before row selection occurs.

toolbarClick EmitType<ClickEventArgs>

Triggers when toolbar item is clicked.

adaptiveUIMode AdaptiveMode

One of the adaptiveUIMode enumeration that specifies the Adaptive Mode. The default value is Both.

aggregates AggregateRowModel[]

Configures the Grid aggregate rows.

<template>
        <ejs-grid :dataSource='data'>
            <e-columns>
                <e-column field='OrderID' headerText='Order ID' textAlign='right' width=120></e-column>
                <e-column field='Freight' format='C2' width=150 textAlign='right'></e-column>
            </e-columns>
            <e-aggregates>
                <e-aggregate>
                    <e-columns>
                        <e-column format='C2' type="Sum" field="Freight" :footerTemplate='footerSum'></e-column>
                    </e-columns>
                </e-aggregate>
          </e-aggregates>
        </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Aggregate } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      footerSum: function () {
        return  { template : Vue.component('sumTemplate', {template: `<span>Sum: </span>`, data () {return { data: {}}; }})
          }}};
  },
  provide: { grid: [Aggregate] }
}
</script>

Check the Aggregates for its configuration.

allowExcelExport boolean

If allowExcelExport set to true, then it will allow the user to export grid to Excel file.

Check the ExcelExport to configure exporting document.

<template>
  <div id="app">
    <ejs-grid ref="grid" id="Grid" :dataSource="data" :toolbar="toolbarOptions" :allowExcelExport="true">
    </ejs-grid>
  </div>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Toolbar, ExcelExport } from "@syncfusion/ej2-vue-grids";
import { orderData } from "./dataSource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: orderData,
      toolbarOptions: ["ExcelExport"]
    };
  },
  provide: { grid: [Toolbar, ExcelExport] }
};
</script>

allowFiltering boolean

If allowFiltering set to true the filter bar will be displayed.
If set to false the filter bar will not be displayed.
Filter bar allows the user to filter grid records with required criteria.

Check the Filtering to customize its default behavior.

<template>
  <ejs-grid :dataSource="data" :allowFiltering="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Filter } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    };
  },
  provide: { grid: [Filter] }
};
</script>

allowGrouping boolean

If allowGrouping set to true, then it will allow the user to dynamically group or ungroup columns.
Grouping can be done by drag and drop columns from column header to group drop area.

Check the Grouping to customize its default behavior.

<template>
  <ejs-grid :dataSource="data" :allowGrouping="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Group  } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    };
  },
  provide: { grid: [Group ] }
};
</script>

allowKeyboard boolean

Enables or disables the key board interaction of Grid.

allowMultiSorting boolean

If allowMultiSorting set to true, then it will allow the user to sort multiple column in the grid.

allowSorting should be true.

<template>
  <ejs-grid :dataSource="data" :allowSorting="true" :allowMultiSorting="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Sort } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
  provide: { grid: [Sort] }
};
</script>

allowPaging boolean

If allowPaging is set to true, the pager renders at the footer of the Grid. It is used to handle page navigation in the Grid.

Check the Paging to configure the grid pager.

allowPdfExport boolean

If allowPdfExport set to true, then it will allow the user to export grid to Pdf file.

Check the Pdfexport to configure the exporting document.

<template>
<ejs-grid :dataSource="data" :toolbar="toolbarOptions" :allowPdfExport="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Toolbar, PdfExport } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
      toolbarOptions: ["PdfExport"]
    }; },
  provide: { grid: [Toolbar, PdfExport] }
};
</script>

allowReordering boolean

If allowReordering is set to true, Grid columns can be reordered.
Reordering can be done by drag and drop of a particular column from one index to another index.

If Grid is rendered with stacked headers, reordering is allowed only at the same level as the column headers.

<template>
  <ejs-grid :dataSource="data" :allowReordering="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Reorder } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
  provide: { grid: [Reorder] }
};
</script>

allowResizing boolean

If allowResizing is set to true, Grid columns can be resized.

<template>
  <ejs-grid :dataSource="data" :allowResizing='true'></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Resize  } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
  provide: { grid: [Resize ] }
};
</script>

allowRowDragAndDrop boolean

If allowRowDragAndDrop is set to true, you can drag and drop grid rows at another grid.

<template>
  <ejs-grid :dataSource="data" :allowRowDragAndDrop="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, RowDD  } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    };  },
  provide: { grid: [RowDD ] }
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>
</script>

allowSelection boolean

If allowSelection is set to true, it allows selection of (highlight row) Grid records by clicking it.

<template>
  <ejs-grid :dataSource="data" :allowSelection="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
};
</script>
</script>

allowSorting boolean

If allowSorting is set to true, it allows sorting of grid records when column header is clicked.

Check the Sorting to customize its default behavior.

<template>
  <ejs-grid :dataSource="data" :allowSorting="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Sort } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
  provide: { grid: [Sort] }
};
</script>

allowTextWrap boolean

If allowTextWrap set to true,
then text content will wrap to the next line when its text content exceeds the width of the Column Cells.

<template>
  <ejs-grid :dataSource="data" allowTextWrap="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; }
};
</script>

autoFit boolean

If autoFit set to true, then it will auto fit the columns based on given width.

childGrid GridModel

Defines Grid options to render child Grid.
It requires the queryString for parent
and child relationship.

Check the Child Grid for its configuration.

clipMode ClipMode

Defines the mode of clip. The available modes are,
Clip: Truncates the cell content when it overflows its area.
Ellipsis: Displays ellipsis when the cell content overflows its area.
EllipsisWithTooltip: Displays ellipsis when the cell content overflows its area,
also it will display the tooltip while hover on ellipsis is applied.

<template>
  <ejs-grid :dataSource="data" clipMode="Clip"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    };
  },
};
</script>

columnChooserSettings ColumnChooserSettingsModel

Configures the column chooser in the Grid.

columnMenuItems ColumnMenuItem[]|ColumnMenuItemModel[]

columnMenuItems defines both built-in and custom column menu items.



The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • Filter - Filter options will show based on filterSettings property like checkbox filter, excel filter, menu filter.

columnQueryMode ColumnQueryModeType

columnQueryModeprovides options to retrive data from the datasource.Their types are

  • All: It Retrives whole datasource.
  • Schema: Retrives data for all the defined columns in grid from the datasource.
  • ExcludeHidden: Retrives data only for visible columns of grid from the dataSource.

columns Column[]|string[]|ColumnModel[]

Defines the schema of dataSource.
If the columns declaration is empty or undefined then the columns are automatically generated from data source.

<template>
  <ejs-grid :dataSource="data">
    <e-columns>
      <e-column field="OrderID" headerText="Order ID" textAlign="right" width="120"></e-column>
      <e-column field="Freight" format="C2" width="150" textAlign="right"></e-column>
    </e-columns>
  </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
};
</script>

contextMenuItems ContextMenuItem[]|ContextMenuItemModel[]

contextMenuItems defines both built-in and custom context menu items.



The available built-in items are,

  • AutoFitAll - Auto fit the size of all columns.
  • AutoFit - Auto fit the current column.
  • Group - Group by current column.
  • Ungroup - Ungroup by current column.
  • Edit - Edit the current record.
  • Delete - Delete the current record.
  • Save - Save the edited record.
  • Cancel - Cancel the edited state.
  • Copy - Copy the selected records.
  • PdfExport - Export the grid as Pdf format.
  • ExcelExport - Export the grid as Excel format.
  • CsvExport - Export the grid as CSV format.
  • SortAscending - Sort the current column in ascending order.
  • SortDescending - Sort the current column in descending order.
  • FirstPage - Go to the first page.
  • PrevPage - Go to the previous page.
  • LastPage - Go to the last page.
  • NextPage - Go to the next page.

cssClass string

Defines the own class for the grid element.

currentAction ActionArgs

Gets or sets the current action details.

currentViewData Object[]

Gets the currently visible records of the Grid.

dataSource Object|DataManager|DataResult

It is used to render grid table rows.
If the dataSource is an array of JavaScript objects,
then Grid will create instance of DataManager
from this dataSource.
If the dataSource is an existing DataManager,
the Grid will not initialize a new one.

Check the available Adaptors to customize the data operation.

<template>
  <ejs-grid :dataSource="data"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
};
</script>

detailTemplate string|Function

The detail template allows you to show or hide additional information about a particular row.

It accepts either the template string or the HTML element ID.

editSettings EditSettingsModel

Configures the edit settings.

<template>
  <ejs-grid :dataSource="data" :editSettings="editSettings" :toolbar="toolbar"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Edit, Toolbar } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
      editSettings: {allowEditing: true, allowAdding: true, allowDeleting: true },
      toolbar: ["Add", "Edit", "Delete", "Update", "Cancel"]
    }; },
  provide: { grid: [Edit, Toolbar] }
};
</script>

ej2StatePersistenceVersion string

Defines the version for Grid persistence.

emptyRecordTemplate string|Function

The empty record template that renders customized element or text or image instead of displaying the empty record message in the grid.

It accepts either the template string or the HTML element ID.

enableAdaptiveUI boolean

If enableAdaptiveUI set to true the grid filter, sort, and edit dialogs render adaptively.

enableAltRow boolean

If enableAltRow is set to true, the grid will render with e-altrow CSS class to the alternative tr elements.

Check the AltRow to customize the styles of alternative rows.

<template>
  <ejs-grid :dataSource="data" :enableAltRow="false"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
};
</script>

enableAutoFill boolean

If enableAutoFill is set to true, then the auto fill icon will displayed on cell selection for copy cells.
It requires the selection mode to be Cell and cellSelectionMode to be Box.

<template>
  <ejs-grid :dataSource="data" :enableAutoFill="true" :selectionSettings="selectionOptions"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
      selectionOptions: { cellSelectionMode: "Box", mode: "Cell" }
    }; }
};
</script>

enableColumnSpan boolean

Enables or disables column spanning for adjacent cells with similar data.
When enabled, the grid merges adjacent cells with identical data between columns into a single cell, spanning multiple columns to enhance data presentation.

<template>
  <ejs-grid :dataSource="data" :enableColumnSpan='true' ></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
    }; }
};
</script>

enableColumnVirtualization boolean

If enableColumnVirtualization set to true, then the Grid will render only the columns visible within the view-port
and load subsequent columns on horizontal scrolling. This helps to load large dataset of columns in Grid.

<template>
  <ejs-grid :dataSource="data" height=300 :enableVirtualization="true" :enableColumnVirtualization="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, VirtualScroll  } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
  provide: { grid: [VirtualScroll] }
};
</script>

enableHeaderFocus boolean

If enableHeaderFocus set to true, then header element will be focused when focus moves to grid.

enableHover boolean

If enableHover is set to true, the row hover is enabled in the Grid.

<template>
  <ejs-grid :dataSource="data" :enableHover='true' ></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
    }; }
};
</script>

enableHtmlSanitizer boolean

Specifies whether to display or remove the untrusted HTML values in the Grid component.
If ‘enableHtmlSanitizer’ set to true, the component will sanitize any suspected untrusted strings and scripts before rendering them.

enableImmutableMode boolean

If enableImmutableMode is set to true, the grid will reuse old rows if it exists in the new result instead of
full refresh while performing the grid actions.

enableInfiniteScrolling boolean

If enableInfiniteScrolling set to true, then the data will be loaded in Grid when the scrollbar reaches the end.
This helps to load large dataset in Grid.

<template>
  <ejs-grid :dataSource="data" height="300" :enableInfiniteScrolling="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, VirtualScroll } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
  provide: { grid: [VirtualScroll] }
};
</script>

enablePersistence boolean

Enable or disable persisting component’s state between page reloads.

enableRowSpan boolean

Enables or disables row spanning for adjacent cells with similar data.
When enabled, the grid merges adjacent cells with identical data between rows into a single cell, spanning multiple rows to improve readability.

<template>
  <ejs-grid :dataSource="data" :enableRowSpan='true' ></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
    }; }
};
</script>

enableRtl boolean

Enable or disable rendering component in right to left direction.

enableStickyHeader boolean

If ‘enableStickyHeader’ set to true, then the user can able to make the column headers visible when the document is scrolled.

enableVirtualMaskRow boolean

Specifies the shimmer effect for Grid virtual and infinite scrolling.

enableVirtualization boolean

If enableVirtualization set to true, then the Grid will render only the rows visible within the view-port
and load subsequent rows on vertical scrolling. This helps to load large dataset in Grid.

<template>
  <ejs-grid :dataSource="data" height=300 :enableVirtualization="true"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, VirtualScroll  } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data
    }; },
  provide: { grid: [VirtualScroll] }
};
</script>

exportGrids string[]

Defines the id of the grids that needs to be exported

filterSettings FilterSettingsModel

Configures the filter settings of the Grid.

<template>
  <ejs-grid :dataSource="data" :allowFiltering="true" :filterSettings="filterOptions"></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Filter } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
      filterOptions: { type: "Menu" }
    }; },
  provide: { grid: [Filter] }
};
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-grids/styles/material.css";
</style>

frozenColumns number

Gets or sets the number of frozen columns.

<template>
  <ejs-grid :dataSource="data" :frozenColumns=2 ></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Freeze } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource";
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
    }; },
  provide: { grid: [Freeze] }
};
</script>

frozenRows number

Gets or sets the number of frozen rows.

<template>
  <ejs-grid :dataSource="data" :frozenRows=2></ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Freeze } from "@syncfusion/ej2-vue-grids";
import { data } from "./datasource" ;
Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: data,
    }; },
  provide: { grid: [Freeze] }
};
</script>

gridLines GridLine

Defines the mode of grid lines. The available modes are,

  • Both: Displays both horizontal and vertical grid lines.
  • None: No grid lines are displayed.
  • Horizontal: Displays the horizontal grid lines only.
  • Vertical: Displays the vertical grid lines only.
  • Default: Displays grid lines based on the theme.
<template>
    <ejs-grid :dataSource='data' gridLines='Both'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
    };
  },
}
</script>

groupSettings GroupSettingsModel

Configures the group settings.

<template>
    <ejs-grid :dataSource='data' :allowGrouping='true' :groupSettings='groupOptions'>
        <e-columns>
            <e-column field='OrderID' headerText='Order ID' textAlign='right' width=120></e-column>
            <e-column field='Freight' format='C2' width=150 textAlign='right'></e-column>
        </e-columns>
    </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Group } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      groupOptions: { columns: ['Freight'] }
    };
  },
  provide: { grid: [Group] }
}
</script>

height string|number

Defines the scrollable height of the grid content.

<template>
    <ejs-grid :dataSource='data' height='400'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
    };
  },
}
</script>

hierarchyPrintMode HierarchyGridPrintMode

Defines the hierarchy grid print modes. The available modes are

  • Expanded - Prints the master grid with expanded child grids.
  • All - Prints the master grid with all the child grids.
  • None - Prints the master grid alone.

infiniteScrollSettings InfiniteScrollSettingsModel

Configures the infinite scroll settings.

<template>
   <ejs-grid :dataSource='data' height=300 :enableInfiniteScrolling='true' :pageSettings='pageOptions' :infiniteScrollSettings='infiniteOptions'>
   </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, InfiniteScroll } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      pageOptions: { pageSize: 50 },
      infiniteScrollSettings: { enableCache: true, maxBlocks: 3, initialBlocks: 3 }
    };
  },
  provide: { grid: [InfiniteScroll] }
}
</script>

isRowPinned PinRow|Function

Determines if a row should be pinned at the top. When not set, no rows are pinned.
Pinned rows remain visible across paging, scrolling and other data actions.

isRowSelectable RowSelectable|string

Determines whether a row can be selected.
When not set, all rows are considered selectable.

loadingIndicator LoadingIndicatorModel

Configures the Loading Indicator of the Grid.

locale string

Overrides the global culture and localization value for this component. Default global culture is ‘en-US’.

pageSettings PageSettingsModel

Configures the pager in the Grid.

<template>
    <ejs-grid :dataSource='data' :allowPaging="true" :pageSettings='pageOptions'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      pageOptions: { currentPage: 1, pageSize: 12, pageCount: 8, pageSizes: true },
    };
  },
  provide: { grid: [Page] }
}
</script>

pagerTemplate string|Function

It used to render pager template

parentDetails ParentDetails

Gets the parent Grid details.

printMode PrintMode

Defines the print modes. The available print modes are

  • AllPages: Prints all pages of the Grid.
  • CurrentPage: Prints the current page of the Grid.
<template>
    <ejs-grid :dataSource='data' printMode='CurrentPage' :allowPaging="true" :toolbar='toolbarOptions'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Page, Toolbar } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      toolbarOptions: ['Print'],
    };
  },
  provide: { grid: [Page, Toolbar] }
}
</script>

query Query

Defines the external Query
that will be executed along with data processing.

<template>
    <ejs-grid :dataSource='data' :query='query'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { DataManager, ODataAdaptor, Query } from "@syncfusion/ej2-data";

Vue.use(GridPlugin);
export default {
  data() {
    let SERVICE_URI = "https://js.syncfusion.com/demos/ejServices/Wcf/Northwind.svc/Orders?$top=7";
    return {
      data: new DataManager({
        url: SERVICE_URI,
        adaptor: new ODataAdaptor()
      }),
      query: new Query().addParams('ej2grid', 'true');
    };
  },
}
</script>

queryString string

Defines the relationship between parent and child datasource. It acts as the foreign key for parent datasource.

resizeSettings ResizeSettingsModel

Defines the resizing behavior of the Grid.

rowDropSettings RowDropSettingsModel

Configures the row drop settings.

rowHeight number

Defines the height of Grid rows.

<template>
    <ejs-grid :dataSource='data' rowHeight='20'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
    };
  },
}
</script>

rowRenderingMode RowRenderingDirection

Defines the grid row elements rendering direction. The available directions are,

  • Horizontal: Renders the grid row elements in the horizontal direction
  • Vertical: Renders the grid row elements in the vertical direction

rowTemplate string|Function

The row template that renders customized rows from the given template.
By default, Grid renders a table row for every data source item.

searchSettings SearchSettingsModel

Configures the search behavior in the Grid.

<template>
    <ejs-grid :dataSource='data' :searchSettings='searchOptions' :toolbar='toolbarOptions'>
        <e-columns>
            <e-column field='CustomerID' headerText='Customer ID' width=120></e-column>
            <e-column field='Freight' format='C2' width=150 textAlign='right'></e-column>
        </e-columns>
    </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Search, Toolbar } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      toolbarOptions: ['Search'],
      searchOptions: { fields: ['CustomerID'], key: 'Ha' }
    };
  },
  provide: { grid: [Search, Toolbar] }
}
</script>

selectedRowIndex number

The selectedRowIndex allows you to select a row at initial rendering.
You can also get the currently selected row index.

<template>
    <ejs-grid :dataSource='data' :selectedRowIndex='1'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
    };
  },
}
</script>

selectionSettings SelectionSettingsModel

Configures the selection settings.

<template>
    <ejs-grid :dataSource='data' :selectionSettings='selectionOptions'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      selectionOptions: { mode: 'Cell', cellSelectionMode: 'Box', type: 'Multiple' }
    };
  },
}
</script>

showColumnChooser boolean

If showColumnChooser is set to true, it allows you to dynamically show or hide columns.

Check the ColumnChooser for its configuration.

<template>
    <ejs-grid :dataSource='data' :showColumnChooser='true' :toolbar='toolbarOptions'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, ColumnChooser, Toolbar } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      toolbarOptions: ['ColumnChooser']
    };
  },
  provide: { grid: [ColumnChooser, Toolbar] }
}
</script>

showColumnMenu boolean

If showColumnMenu set to true, then it will enable the column menu options in each columns.

Check the Column menu for its configuration.

<template>
    <ejs-grid :dataSource='data' :showColumnMenu='true'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, ColumnMenu } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
    };
  },
  provide: { grid: [ColumnMenu] }
}
</script>

showHider ShowHide

The showHider is used to manipulate column’s show/hide operation in the Grid.

sortSettings SortSettingsModel

Configures the sort settings.

<template>
    <ejs-grid :dataSource='data' :allowSorting='true' :sortSettings='sortOptions' >
        <e-columns>
            <e-column field='OrderID' headerText='Order ID' textAlign='right' width=120></e-column>
            <e-column field='Freight' format='C2' width=150 textAlign='right'></e-column>
        </e-columns>
    </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Sort } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      sortOptions: { columns: [{ field: 'OrderID', direction: 'Ascending' }] }
    };
  },
  provide: { grid: [Sort] }
}
</script>

textWrapSettings TextWrapSettingsModel

Configures the text wrap in the Grid.

<template>
    <ejs-grid :dataSource='data' :allowTextWrap='true' :textWrapSettings='textOption'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      textOption:  { wrapMode: 'Both' },
    };
  },
}
</script>

toolbar []

toolbar defines the ToolBar items of the Grid.
It contains built-in and custom toolbar items.
If a string value is assigned to the toolbar option, it is considered as the template for the whole Grid ToolBar.
If an array value is assigned, it is considered as the list of built-in and custom toolbar items in the Grid’s Toolbar.



The available built-in ToolBar items are:

  • Add: Adds a new record.
  • Edit: Edits the selected record.
  • Update: Updates the edited record.
  • Delete: Deletes the selected record.
  • Cancel: Cancels the edit state.
  • Search: Searches records by the given key.
  • Print: Prints the Grid.
  • ExcelExport - Export the Grid to Excel(excelExport() method manually to make export.)
  • PdfExport - Export the Grid to PDF(pdfExport() method manually to make export.)
  • CsvExport - Export the Grid to CSV(csvExport() method manually to make export.)


    The following code example implements the custom toolbar items.

    Check the Toolbar to customize its default items.

<template>
    <ejs-grid :dataSource='data' :toolbar='toolbarOptions'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin, Toolbar } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
      toolbarOptions: ['Search','Print']
    };
  },
  provide: { grid: [Toolbar] }
}
</script>

toolbarTemplate string|Function

It used to render toolbar template

width string|number

Defines the Grid width.

<template>
    <ejs-grid :dataSource='data' width='700'> </ejs-grid>
</template>
<script>
import Vue from "vue";
import { GridPlugin } from "@syncfusion/ej2-vue-grids";
import { gridData } from './data';

Vue.use(GridPlugin);
export default {
  data() {
    return {
      data: gridData,
    };
  },
}
</script>